;----------------------------------------------------------------------------------
;	FILE:			Eperipheral_registers.H
;
;	Description:	Generic Header file for 280x "EPeripheral" register addresses.
;
;	Version: 		2.00
;
;   Target:  		TMS320F280x 
;
;	Type: 			Device dependent
;
;----------------------------------------------------------------------------------
;  Copyright Texas Instruments  2004-2005                                			
;----------------------------------------------------------------------------------
;  Revision History:
;----------------------------------------------------------------------------------
;  Date	     | Description
;----------------------------------------------------------------------------------
;  06/30/05  | Release 1.0  	New release.
;  06/27/06  | Release 2.00  	Added more ADC registers.
;----------------------------------------------------------------------------------
;  06/27/06  | Release 2.0  	Updated all the projects to the rev 2.0  format
;            |                  with the addition of memory blocking and new
;            |                  directory structure and simplified libraries.
;---------------------------------------------------------------------------------- 
;FILE_TAG: .\lib\drvlib280x\include\EPeripheral_registers.inc 

; EPWM
EPWM1_BASE		.set	0x6800
TBPHSHR1		.set 	EPWM1_BASE+0x2
TBPHS1 			.set 	EPWM1_BASE+0x3
TBCTR1 			.set 	EPWM1_BASE+0x4
TBPRD1 			.set 	EPWM1_BASE+0x5
CMPAHR1			.set	EPWM1_BASE+0x8
CMPA1 			.set 	EPWM1_BASE+0x9
CMPB1 			.set 	EPWM1_BASE+0xA
DBRED1 			.set 	EPWM1_BASE+0x10
DBFED1 			.set 	EPWM1_BASE+0x11
TZSEL1 			.set 	EPWM1_BASE+0x12
TZCTL1 			.set 	EPWM1_BASE+0x14
TZEINT1 		.set 	EPWM1_BASE+0x15
TZFLG1 			.set 	EPWM1_BASE+0x16
TZCLR1 			.set 	EPWM1_BASE+0x17
TZFRC1 			.set 	EPWM1_BASE+0x18
ETSEL1 			.set 	EPWM1_BASE+0x19
ETPS1 			.set 	EPWM1_BASE+0x1A
ETFLG1 			.set 	EPWM1_BASE+0x1B
ETCLR1 			.set 	EPWM1_BASE+0x1C
ETFRC1 			.set 	EPWM1_BASE+0x1D

EPWM2_BASE		.set	0x6840
TBPHSHR2		.set 	EPWM2_BASE+0x2
TBPHS2 			.set 	EPWM2_BASE+0x3
TBCTR2 			.set 	EPWM2_BASE+0x4
TBPRD2 			.set 	EPWM2_BASE+0x5
CMPAHR2			.set	EPWM2_BASE+0x8
CMPA2 			.set 	EPWM2_BASE+0x9
CMPB2 			.set 	EPWM2_BASE+0xA
DBRED2			.set 	EPWM2_BASE+0x10
DBFED2 			.set 	EPWM2_BASE+0x11
TZSEL2 			.set 	EPWM2_BASE+0x12
TZCTL2 			.set 	EPWM2_BASE+0x14
TZEINT2 		.set 	EPWM2_BASE+0x15
TZFLG2 			.set 	EPWM2_BASE+0x16
TZCLR2 			.set 	EPWM2_BASE+0x17
TZFRC2 			.set 	EPWM2_BASE+0x18
ETSEL2 			.set 	EPWM2_BASE+0x19
ETPS2 			.set 	EPWM2_BASE+0x1A
ETFLG2 			.set 	EPWM2_BASE+0x1B
ETCLR2 			.set 	EPWM2_BASE+0x1C
ETFRC2 			.set 	EPWM2_BASE+0x1D

EPWM3_BASE		.set	0x6880
TBPHSHR3		.set 	EPWM3_BASE+0x2
TBPHS3 			.set 	EPWM3_BASE+0x3
TBCTR3 			.set 	EPWM3_BASE+0x4
TBPRD3 			.set 	EPWM3_BASE+0x5
CMPAHR3			.set	EPWM3_BASE+0x8
CMPA3 			.set 	EPWM3_BASE+0x9
CMPB3 			.set 	EPWM3_BASE+0xA
DBRED3 			.set 	EPWM3_BASE+0x10
DBFED3 			.set 	EPWM3_BASE+0x11
TZSEL3 			.set 	EPWM3_BASE+0x12
TZCTL3 			.set 	EPWM3_BASE+0x14
TZEINT3 		.set 	EPWM3_BASE+0x15
TZFLG3 			.set 	EPWM3_BASE+0x16
TZCLR3 			.set 	EPWM3_BASE+0x17
TZFRC3 			.set 	EPWM3_BASE+0x18
ETSEL3 			.set 	EPWM3_BASE+0x19
ETPS3 			.set 	EPWM3_BASE+0x1A
ETFLG3 			.set 	EPWM3_BASE+0x1B
ETCLR3 			.set 	EPWM3_BASE+0x1C
ETFRC3 			.set 	EPWM3_BASE+0x1D

EPWM4_BASE		.set	0x68C0
TBPHS4 			.set 	EPWM4_BASE+0x3
TBCTR4 			.set 	EPWM4_BASE+0x4
TBPRD4 			.set 	EPWM4_BASE+0x5
CMPAHR4			.set	EPWM4_BASE+0x8
CMPA4 			.set 	EPWM4_BASE+0x9
CMPB4 			.set 	EPWM4_BASE+0xA
DBRED4 			.set 	EPWM4_BASE+0x10
DBFED4 			.set 	EPWM4_BASE+0x11
TZSEL4 			.set 	EPWM4_BASE+0x12
TZCTL4 			.set 	EPWM4_BASE+0x14
TZEINT4 		.set 	EPWM4_BASE+0x15
TZFLG4 			.set 	EPWM4_BASE+0x16
TZCLR4 			.set 	EPWM4_BASE+0x17
TZFRC4 			.set 	EPWM4_BASE+0x18
ETSEL4 			.set 	EPWM4_BASE+0x19
ETPS4 			.set 	EPWM4_BASE+0x1A
ETFLG4 			.set 	EPWM4_BASE+0x1B
ETCLR4 			.set 	EPWM4_BASE+0x1C
ETFRC4 			.set 	EPWM4_BASE+0x1D

EPWM5_BASE		.set	0x6900
TBPHS5 			.set 	EPWM5_BASE+0x3
TBCTR5 			.set 	EPWM5_BASE+0x4
TBPRD5 			.set 	EPWM5_BASE+0x5
CMPA5 			.set 	EPWM5_BASE+0x9
CMPB5 			.set 	EPWM5_BASE+0xA
DBRED5 			.set 	EPWM5_BASE+0x10
DBFED5 			.set 	EPWM5_BASE+0x11

EPWM6_BASE		.set	0x6940
TBPHS6 			.set 	EPWM6_BASE+0x3
TBCTR6 			.set 	EPWM6_BASE+0x4
TBPRD6 			.set 	EPWM6_BASE+0x5
CMPA6			.set 	EPWM6_BASE+0x9
CMPB6 			.set 	EPWM6_BASE+0xA
DBRED6 			.set 	EPWM6_BASE+0x10
DBFED6 			.set 	EPWM6_BASE+0x11
TZSEL6 			.set 	EPWM6_BASE+0x12
TZCTL6 			.set 	EPWM6_BASE+0x14
TZEINT6 		.set 	EPWM6_BASE+0x15
TZFLG6 			.set 	EPWM6_BASE+0x16
TZCLR6			.set 	EPWM6_BASE+0x17
TZFRC6 			.set 	EPWM6_BASE+0x18
ETSEL6 			.set 	EPWM6_BASE+0x19
ETPS6 			.set 	EPWM6_BASE+0x1A
ETFLG6 			.set 	EPWM6_BASE+0x1B
ETCLR6 			.set 	EPWM6_BASE+0x1C
ETFRC6 			.set 	EPWM6_BASE+0x1D

; ADC
ADCTRL1 		.set 	0x7100
ADCTRL2			.set 	0x7101
ADCTRL3			.set 	0x7118
ADCMAXCONV		.set	0x7102
ADCASEQSR		.set	0x7107
ADCREFSEL		.set	0x711C
ADCOFFTRIM		.set	0x711D
ADCCHSELSEQ1	.set	0x7103
ADCCHSELSEQ2	.set	0x7104
ADCCHSELSEQ3	.set	0x7105
ADCCHSELSEQ4	.set	0x7106
ADCST 			.set 	0x7119
INT_SEQ1_CLR 	.set 	0x0010

ADCRESULT0 		.set 	0x7108
ADCRESULT1 		.set 	0x7109
ADCRESULT2 		.set 	0x710A
ADCRESULT3 		.set 	0x710B
ADCRESULT4 		.set 	0x710C
ADCRESULT5 		.set 	0x710D
ADCRESULT6 		.set 	0x710E
ADCRESULT7 		.set 	0x710F
ADCRESULT8 		.set 	0x7110
ADCRESULT9 		.set 	0x7111
ADCRESULT10 	.set 	0x7112
ADCRESULT11 	.set 	0x7113
ADCRESULT12 	.set 	0x7114
ADCRESULT13 	.set 	0x7115
ADCRESULT14 	.set 	0x7116
ADCRESULT15 	.set 	0x7117

ADCPF0R0 		.set 	0x0B00
ADCPF0R1 		.set 	0x0B01
ADCPF0R2 		.set 	0x0B02
ADCPF0R3 		.set 	0x0B03
ADCPF0R4 		.set 	0x0B04
ADCPF0R5 		.set 	0x0B05
ADCPF0R6 		.set 	0x0B06
ADCPF0R7 		.set 	0x0B07
ADCPF0R8 		.set 	0x0B08
ADCPF0R9 		.set 	0x0B09
ADCPF0R10 		.set 	0x0B0A
ADCPF0R11 		.set 	0x0B0B
ADCPF0R12 		.set 	0x0B0C
ADCPF0R13 		.set 	0x0B0D
ADCPF0R14 		.set 	0x0B0E
ADCPF0R15 		.set 	0x0B0F

; Interrupts
PIEACK 			.set 	0x0CE1
PIEACK_GROUP1   .set	0x0001
PIEACK_GROUP2   .set 	0x0002
PIEACK_GROUP3   .set 	0x0004
PIEACK_GROUP4   .set 	0x0008
PIEACK_GROUP5   .set 	0x0010
PIEACK_GROUP6   .set 	0x0020
PIEACK_GROUP7   .set 	0x0040
PIEACK_GROUP8   .set 	0x0080
PIEACK_GROUP9   .set 	0x0100
PIEACK_GROUP10  .set 	0x0200
PIEACK_GROUP11  .set 	0x0400
PIEACK_GROUP12  .set 	0x0800

; GPIO Port B
GPBMUX1 		.set 	0x6F96
GPBDIR 			.set 	0x6F9A
GPBDAT			.set 	0x6FC8
GPBSET 			.set 	0x6FCA
GPBCLEAR		.set 	0x6FCC
GPBTOGGLE		.set 	0x6FCE


CONTEXT_SAVE 	.macro		
			PUSH AR1H:AR0H ; 32-bit
			PUSH XAR2 ; 32-bit
			PUSH XAR3 ; 32-bit
			PUSH XAR4 ; 32-bit
			PUSH XAR5 ; 32-bit
			PUSH XAR6 ; 32-bit
			PUSH XAR7 ; 32-bit
			PUSH XT ; 32-bit
		.endm
		
CONTEXT_REST		.macro
			POP XT
			POP XAR7
			POP XAR6
			POP XAR5
			POP XAR4
			POP XAR3
			POP XAR2
			POP AR1H:AR0H
		.endm







;FILE_TAG: .\lib\dpslib280x\include\ControlLawMacro.inc 

;============================================================================
;	CONTROL_LAW Macro module - 2 Pole / 2 Zero
;============================================================================
;			______________________
;			|	   CNTL_2P2Z	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| Ref			  	  |
;			|				  Out |-->
;		 -->| Fdbk			  	  |
;			|_____________________|
;
;		Ref, Fdbk, Out: pointers to Signal Nets
;
; Description:
; ------------
; Performs a second order difference equation of the form:
;
;       		B2 z^2 + B1 z + B0
; U(z)/E(z) = ---------------------------------------
;       		-A2 z^2 - A1 z + 1	
;
; U(n)= A1*U(n-1)+A2*U(n-2)+B0*E(n)+B1*E(n-1)+B2*E(n-2)
;
; where	U(n-1) => output from last sample cycle
;		U(n-2) => output from 2 samples past
;		E(n)   => present error
;		E(n-1) => error from last sample cycle
;		E(n-2) => error from 2 samples past
;
;		|--------|
;		| y(n-1) |0  CNTL_2P2Z_DBUFF
;		|--------|
;		| y(n-2) |2
; 		|--------|	
;		|  e(n)  |4	
;		|--------|	
;		| e(n-1) |6
;		|--------|
;		| e(n-2) |8
;		|--------|
;
;====================================
CNTL_2P2Z_INIT	.macro x, y
;====================================
; Variable Declarations
_CNTL_2P2Z_Ref:x:	.usect "CNTL_2P2Z_Data:x:",2,1,1	; Input Terminal 1
_CNTL_2P2Z_Fdbk:x:	.usect "CNTL_2P2Z_Data:x:",2 		; Input Terminal 2
_CNTL_2P2Z_Out:x:	.usect "CNTL_2P2Z_Data:x:",2 		; Output Terminal
CNTL_2P2Z_DBUFF:x: 	.usect "CNTL_2P2Z_Data:x:",10		; "Local" memory (history) 
CNTL_2P2Z_temp:x:	.usect "CNTL_2P2Z_Data:x:",2		; "Local" memory
CNTL_2P2Z_COEFF:x:	.usect "CNTL_2P2Z_Data:x:",14		; "Local" memory (constants)

;Publish Terminal Pointers for access from the C environment (optional)
					.def 	_CNTL_2P2Z_Ref:x:
					.def 	_CNTL_2P2Z_Fdbk:x:
					.def 	_CNTL_2P2Z_Out:x:

		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_CNTL_2P2Z_Ref:x:
			MOVL	@_CNTL_2P2Z_Ref:x:, XAR2
			MOVL	@_CNTL_2P2Z_Fdbk:x:, XAR2
			MOVL	XAR2, #DummyNet
			MOVL	@_CNTL_2P2Z_Out:x:, XAR2

		; Zero the Data Buffer
			MOVL 	XAR2,#CNTL_2P2Z_DBUFF:x:
			RPT		#4 ; 5 times
			||MOV	*XAR2++, #0

		; Load the Co-efficients + Saturation limits
			MOVL 	XAR2, #:y:
			MOVL 	XAR3, #CNTL_2P2Z_COEFF:x:
			MOV		@AR0, #13 ;loop 14 times
CNTL_2P2Z_LOOP:x:
			MOV		ACC, *XAR2++
			MOV		*XAR3++, AL
			BANZ	CNTL_2P2Z_LOOP:x:, AR0--
				.endm

;========================
CNTL_2P2Z	.macro x
;========================
			MOVW	DP, #_CNTL_2P2Z_Ref:x:
			MOVL 	XAR4,@_CNTL_2P2Z_Ref:x:		; Net pointer to Ref (XAR4)
			MOVL 	XAR5,@_CNTL_2P2Z_Fdbk:x:	; Net pointer to Fdbk (XAR5)
			MOVL 	XAR6,@_CNTL_2P2Z_Out:x:		; Net pointer to Out (XAR6)
			MOVL    XAR7,#CNTL_2P2Z_COEFF:x:	; Local coefficient pointer (XAR7)

			SETC    SXM,OVM 
			MOV 	ACC,*XAR4					;Q15
			SUB		ACC,*XAR5					;Q15
			LSL		ACC,#16						;Q31

		; Diff equation
			MOVL 	@CNTL_2P2Z_DBUFF:x:+4,ACC  
			MOVL 	XT,@CNTL_2P2Z_DBUFF:x:+8	; XT=e(n-2),Q31
			QMPYL	ACC,XT,*XAR7++				; b2*e(n-2),Q26*Q31(64-bit result)
            MOVDL   XT,@CNTL_2P2Z_DBUFF:x:+6    ; XT=e(n-1), e(n-2)=e(n-1)
 			QMPYL	P,XT,*XAR7++ 				; ACC=b2*e(n-2) P=b1*e(n-1),Q26*Q31(64-bit result)
 			ADDL	ACC,P						; 64-bit result in Q57, So ACC is in Q25
			MOVDL 	XT,@CNTL_2P2Z_DBUFF:x:+4	; XT=e(n), e(n-1)=e(n)
			QMPYL 	P,XT,*XAR7++				; ACC=b2*e(n-2)+b1*e(n-1), P=b0*e(n),Q26*Q31(64-bit result)
												; 64-bit result in Q57, So ACC is in Q25
			ADDL	ACC,P						; ACC=b2*e(n-2)+b1*e(n-1)+b0*e(n), Q25	
			SFR		ACC,#1
			MOVL	@CNTL_2P2Z_temp:x:,ACC		; Q24

			MOVL 	XT,@CNTL_2P2Z_DBUFF:x:+2	; XT=u(n-2),Q24
			QMPYL 	P,XT,*XAR7++				; P=a2*u(n-2), Q26*Q24(64-bit result)
            MOVDL   XT,@CNTL_2P2Z_DBUFF:x:     	; XT=u(n-1), u(n-2)=u(n-1),Q24
 			QMPYL	ACC,XT,*XAR7++    			; ACC=a2*u(n-2)
 												; 64-bit result in Q50, So ACC is in Q18
 			ADDL 	ACC,P						; ACC=a1*u(n-1)+a2*u(n-2),ACC in Q18
 			LSL		ACC,#5						; Q23
 			ADDL 	ACC,ACC						; Q24
 			ADDL	ACC,@CNTL_2P2Z_temp:x:  	; Q24,ACC=a1*u(n-1)+a2*u(n-2)+b2*e(n-2)+b1*e(n-1)+b0*e(n)
 			MOVL 	@CNTL_2P2Z_DBUFF:x:,ACC		; ACC=u(n)(Q24)

		; Saturate the result [0,1]
			MINL 	ACC,*XAR7++					
			MAXL 	ACC,*XAR7++
		
		;move result to Uout as a Q15
			LSL		ACC,#7
			MOV		*XAR6, AH
			.endm
			
;FILE_TAG: .\lib\dpslib280x\include\DigitalFilterMacro.inc 
		
;=================================================================================
;	FILT_2P2Z Macro module - 2 Pole / 2 Zero
;=================================================================================
;			______________________
;			|	   FILT_2P2Z	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 	| 				  	  |
;		 -->|In				  Out |-->
;		 	| 				  	  |
;			|_____________________|
;
;		In, Out: pointers to Signal Nets
;
;
; Description:
; ------------
; Performs a second order difference equation of the form:
;
;       		B2 z^2 + B1 z + B0
; U(z)/E(z) = ---------------------------------------
;       		-A2 z^2 - A1 z + 1	
;
; U(n)= A1*U(n-1)+A2*U(n-2)+B0*E(n)+B1*E(n-1)+B2*E(n-2)
;
; where	U(n-1) => output from last sample cycle
;		U(n-2) => output from 2 samples past
;		E(n)   => present error
;		E(n-1) => error from last sample cycle
;		E(n-2) => error from 2 samples past
;
;		|		 |
;		|--------|
;		| y(n-1) |0  FILT_2P2Z_DBUFF
;		|--------|
;		| y(n-2) |2
; 		|--------|	
;		|  e(n)  |4	
;		|--------|	
;		| e(n-1) |6
;		|--------|
;		| e(n-2) |8
;		|--------|
;
;
; Revision History:
;----------------------------------------------------------------------------------
; Date		| Author	| Description
;----------------------------------------------------------------------------------
; 11/22/03	| SD		| TI original release
; 06/06/04	| DAF		| Modified to support Signal Net interfacing and Macro calls
; _________________________________________________________________________________

FILTER_Q29		.set	1
FILTER_Q26		.set	0


;===========================
FILT_2P2Z_INIT	.macro x, y
;===========================
; Variable Declarations
_FILT_2P2Z_In:x:	.usect "FILT_data",2,1,1	; Input Terminal 1
_FILT_2P2Z_Out:x:	.usect "FILT_data",2 		; Output Terminal 2
FILT_2P2Z_DBUFF:x: 	.usect "FILT_data",10		; "Local" memory (history)
FILT_2P2Z_COEFF:x:	.usect "FILT_data",14		; "Local" memory (constants)
FILT_2P2Z_temp:x:	.usect "FILT_data",1		; "Local" memory

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_FILT_2P2Z_In:x:
					.def 	_FILT_2P2Z_Out:x:

		; set terminals to point to ZeroNet
			MOVL	XAR2, #_ZeroNet
			MOVW	DP, #_FILT_2P2Z_In:x:
			MOVL	@_FILT_2P2Z_In:x:, XAR2
			MOVL	XAR2, #DummyNet
			MOVL	@_FILT_2P2Z_Out:x:, XAR2
					
		; Zero the Data Buffer
			MOVL 	XAR2,#FILT_2P2Z_DBUFF:x:
			RPT		#4 ; 5 times
			||MOV	*XAR2++, #0

		; Load the Co-efficients + Saturation limits
			MOVL 	XAR2, #:y:
			MOVL 	XAR3, #FILT_2P2Z_COEFF:x:
			MOV	@AR0, #13 ;loop 14 times
FILT_2P2Z_LOOP:x:
			MOV	ACC, *XAR2++
			MOV	*XAR3++, AL
			BANZ	FILT_2P2Z_LOOP:x:, AR0--

				.endm


;========================
FILT_2P2Z		.macro x
;========================
			MOVW	DP, #_FILT_2P2Z_In:x:
			MOVL 	XAR4,@_FILT_2P2Z_In:x:		; Net pointer to In (XAR4)
			MOVL 	XAR5,@_FILT_2P2Z_Out:x:		; Net pointer to Out (XAR5)
			MOVL    XAR7,#FILT_2P2Z_COEFF:x:	; Local coefficient pointer (XAR7)

	.if(!NET_DEBUG) ; i.e. normal operation
			SETC    SXM,OVM 
			MOV 	ACC,*XAR4					;Q15
			LSL		ACC,#16						;Q31

		.if (FILTER_Q26)
		; Diff equation
			MOVL 	@FILT_2P2Z_DBUFF:x:+4,ACC  
			MOVL 	XT,@FILT_2P2Z_DBUFF:x:+8	; XT=e(n-2),Q31
			QMPYL	ACC,XT,*XAR7++				; b2*e(n-2),Q26*Q31(64-bit result)
            MOVDL   XT,@FILT_2P2Z_DBUFF:x:+6    ; XT=e(n-1), e(n-2)=e(n-1)
 			QMPYL	P,XT,*XAR7++ 				; ACC=b2*e(n-2) P=b1*e(n-1),Q26*Q31(64-bit result)
 			ADDL	ACC,P						; 64-bit result in Q57, So ACC is in Q25
			MOVDL 	XT,@FILT_2P2Z_DBUFF:x:+4		; XT=e(n), e(n-1)=e(n)
			QMPYL 	P,XT,*XAR7++				; ACC=b2*e(n-2)+b1*e(n-1), P=b0*e(n),Q26*Q31(64-bit result)
												; 64-bit result in Q57, So ACC is in Q25
			ADDL	ACC,P						; ACC=b2*e(n-2)+b1*e(n-1)+b0*e(n), Q25	
			SFR		ACC,#1
			MOVL	@FILT_2P2Z_temp:x:,ACC		; Q24

			MOVL 	XT,@FILT_2P2Z_DBUFF:x:+2	; XT=u(n-2),Q24
			QMPYL 	P,XT,*XAR7++				; P=a2*u(n-2), Q26*Q24(64-bit result)
            MOVDL   XT,@FILT_2P2Z_DBUFF:x:     	; XT=u(n-1), u(n-2)=u(n-1),Q24
 			QMPYL	ACC,XT,*XAR7++    			; ACC=a2*u(n-2)
 												; 64-bit result in Q50, So ACC is in Q18
 			ADDL 	ACC,P						; ACC=a1*u(n-1)+a2*u(n-2),ACC in Q18
 			LSL		ACC,#5						; Q23
 			ADDL 	ACC,ACC						; Q24
 			ADDL	ACC,@FILT_2P2Z_temp:x:  	; Q24,ACC=a1*u(n-1)+a2*u(n-2)+b2*e(n-2)+b1*e(n-1)+b0*e(n)
 			MOVL 	@FILT_2P2Z_DBUFF:x:,ACC		; ACC=u(n)(Q24)

		; Saturate the result [0,1]
			MINL 	ACC,*XAR7++					
			MAXL 	ACC,*XAR7++
		
		;move result to Uout as a Q15 ?
			LSL		ACC,#7
			MOV		*XAR5, AH
		.endif	

		.if (FILTER_Q29)
		; Diff equation
			MOVL 	@FILT_2P2Z_DBUFF:x:+4,ACC	; Save the input in the stack as Q31  
			MOVL 	XT,@FILT_2P2Z_DBUFF:x:+8	; XT=e(n-2),Q31								
			QMPYL   ACC,XT,*XAR7++				; b2*e(n-2),Q29*Q31(64-bit result in Q60) 
            MOVDL   XT,@FILT_2P2Z_DBUFF:x:+6		; XT=e(n-1), e(n-2)=e(n-1)							
 			QMPYL   P,XT,*XAR7++ 				; ACC=b2*e(n-2) P=b1*e(n-1),Q29*Q31=Q60
 			ADDL	ACC,P						; 64-bit result in Q60, So ACC is in Q28
			MOVDL 	XT,@FILT_2P2Z_DBUFF:x:+4		; XT=e(n), e(n-1)=e(n)							
			QMPYL 	P,XT,*XAR7++				; ACC=b2*e(n-2)+b1*e(n-1), P=b0*e(n),Q29*Q31=Q60
												; 64-bit result in Q60, So ACC is in Q28
			ADDL	ACC,P						; ACC=b2*e(n-2)+b1*e(n-1)+b0*e(n), Q28	
			SFR		ACC,#1
			MOVL	@FILT_2P2Z_temp:x:,ACC		; Q27

			MOVL 	XT,@FILT_2P2Z_DBUFF:x:+2		; XT=u(n-2),Q27							
			QMPYL 	P,XT,*XAR7++				; P=a2*u(n-2), Q29*Q27=Q56
            MOVDL   XT,@FILT_2P2Z_DBUFF:x:		; XT=u(n-1), u(n-2)=u(n-1),Q27						
 			QMPYL   ACC,XT,*XAR7++    			; ACC=a2*u(n-2)
 												; 64-bit result in Q56, So ACC is in Q24
 			ADDL 	ACC,P						; ACC=a1*u(n-1)+a2*u(n-2),ACC in Q24
 			LSL		ACC,#2						; Q26
 			ADDL 	ACC,ACC						; Q27
 			ADDL	ACC,@FILT_2P2Z_temp:x:		; Q27,ACC=a1*u(n-1)+a2*u(n-2)+b2*e(n-2)+b1*e(n-1)+b0*e(n)
 			MOVL 	@FILT_2P2Z_DBUFF:x:,ACC		; ACC=u(n)(Q27)						

		; Saturate the result [0,1]
			MINL 	ACC,*XAR7++					
			MAXL 	ACC,*XAR7++
		
		;move result to Uout as a Q15 ?		
			LSL		ACC,#4
			MOV		*XAR5,AH
		.endif	
	.endif ; !NET_DEBUG


	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
			MOV 	ACC,*XAR4			; mov In directly to Out
			MOV		*XAR5, AL			;  i.e. "In" to "Out" bypass
	.endif ; NET_DEBUG

				.endm


;============================================================================
;	FILT_BIQUAD Macro module - 2nd order filter with Biquad structure
;============================================================================
;			______________________
;			|	  FILT_BIQUAD	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 	| 				  	  |
;		 -->|In				  Out |-->
;		 	| 				  	  |
;			|_____________________|
;
;		In, Out: pointers to Signal Nets
;
;
; Description:
; ------------
; Performs a Low Pass biquad filter algorithm:
;
;	Y(n) = Y(n-1) + (K1/2)*[W(n) + W(n-1)]
;
; where	V(n)= X(n) - Y(n-1) - K2*W(n-1)
;		W(n)= W(n-1) + (K1/2)*[V(n) + V(n-1)]
;		X(n)=> present input
;		K1 	=> 2*pi*Fc*T
;		K2 	=> 1/FilterQ
;		Fc 	=> Filter CutOff freq in Hz
;		T  	=> Sample period in secs
;
; Control Stack Format:
;		|		 |
;		|--------|
;		| V(n)   |0  FILT_BIQUAD_DBUFF
;		|--------|
;		| V(n-1) |2
; 		|--------|
;		| W(n)   |4
;		|--------|
;		| W(n-1) |6
;		|--------|
;		| Y(n)   |8
;		|--------|
;		| Y(n-1) |10
;		|--------|
;
;
; Revision History:
;----------------------------------------------------------------------------------
; Date		| Author	| Description
;----------------------------------------------------------------------------------
; 01/27/04	| DSZ		| Original.
; 06/06/04	| DAF		| Modified to support Signal Net interfacing and Macro calls
; _________________________________________________________________________________

;==============================
FILT_BIQUAD_INIT	.macro x, y
;==============================
; Variable Declarations
_FILT_BIQUAD_In:x:		.usect "BIQUAD_data",2,1,1	; Input Terminal 1
_FILT_BIQUAD_Out:x:		.usect "BIQUAD_data",2 		; Output Terminal 2
FILT_BIQUAD_DBUFF:x: 	.usect "BIQUAD_data",12		; "Local" memory (history)
FILT_BIQUAD_COEFF:x:	.usect "BIQUAD_data",8		; "Local" memory (constants)
FILT_BIQUAD_temp1:x:	.usect "BIQUAD_data",1		; "Local" memory
FILT_BIQUAD_temp2:x:	.usect "BIQUAD_data",1		; "Local" memory

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
						.def 	_FILT_BIQUAD_In:x:
						.def 	_FILT_BIQUAD_Out:x:

		; set terminals to point to ZeroNet
			MOVL	XAR2, #_ZeroNet
			MOVW	DP, #_FILT_BIQUAD_In:x:
			MOVL	@_FILT_BIQUAD_In:x:, XAR2
			MOVL	XAR2, #DummyNet
			MOVL	@_FILT_BIQUAD_Out:x:, XAR2
					
		; Zero the Data Buffer
			MOVL 	XAR2,#FILT_BIQUAD_DBUFF:x:
			RPT		#5 ; 6 times
			||MOV	*XAR2++, #0

		; Load the Co-efficients + Saturation limits
			MOVL 	XAR2, #:y:
			MOVL 	XAR3, #FILT_BIQUAD_COEFF:x:
			MOV		@AR0, #7 ; loop 8 times
FILT_BIQUAD_LOOP:x:
			MOV		ACC, *XAR2++
			MOV		*XAR3++, AL
			BANZ	FILT_BIQUAD_LOOP:x:, AR0--

					.endm

;========================
FILT_BIQUAD		.macro x
;========================
		MOVW	DP, #_FILT_BIQUAD_In:x:
		MOVL 	XAR3,@_FILT_BIQUAD_In:x:		; Net pointer to In (XAR3)
		MOVL 	XAR4,@_FILT_BIQUAD_Out:x:		; Net pointer to Out (XAR4)
		MOVL    XAR7,#FILT_BIQUAD_COEFF:x:		; Local coefficient pointer (XAR7)


	.if(!NET_DEBUG) ; i.e. normal operation

		SETC    SXM,OVM
		; Update Filter taps: Y(n-1)=Y(n), V(n-1)=V(n), W(n-1)=W(n) 
		MOVL	ACC,@FILT_BIQUAD_DBUFF:x:	; Load V(n)
		MOVL	@FILT_BIQUAD_DBUFF:x:+2,ACC	; Store V(n-1)
		MOVL	ACC,@FILT_BIQUAD_DBUFF:x:+4	; Load W(n)
		MOVL	@FILT_BIQUAD_DBUFF:x:+6,ACC	; Store W(n-1)
		MOVL	ACC,@FILT_BIQUAD_DBUFF:x:+8	; Load Y(n)
		MOVL	@FILT_BIQUAD_DBUFF:x:+10,ACC; Store Y(n-1)
						   			   
	; Load and ajust the format of the input X(n)						   			   			   			   
		MOV 	ACC,*XAR3					; Q15
	; Adjust this shift for the subsequent summation						
		LSL		ACC,#13						; Q28
		MOVL	@FILT_BIQUAD_temp1:x:,ACC	; save for later

; Calculate High-Pass Term V(n)
;	V(n) = X(n) - Y(n-1) - K2*W(n-1)
		MOVL 	XT,@FILT_BIQUAD_DBUFF:x:+6	; XT=W(n-1),Q31				
		QMPYL  	ACC,XT,*XAR7++				; P = K2*W(n-1),Q29*Q28(64-bit result in Q57) ACC in Q25
		LSL		ACC,#3						; shift into Q28
		SUBL	ACC,@FILT_BIQUAD_DBUFF:x:+10; ACC = - Y(n-1) - K2*W(n-1)
		ADDL	ACC,@FILT_BIQUAD_temp1:x:	; ACC) = X(n) - Y(n-1) - K2*W(n-1)
		MOVL	@FILT_BIQUAD_DBUFF:x:,ACC	; save V(n) Q28

; Calculate Intermediate Term W(n)
;	W(n) = W(n-1) + (K1/2)*[V(n) + V(n-1)]
 		ADDL	ACC,@FILT_BIQUAD_DBUFF:x:+2	; ACC = V(n) + V(n-1) Q28						 
		MOVL	@FILT_BIQUAD_temp2:x:,ACC
		MOVL 	XT,@FILT_BIQUAD_temp2:x:	; XT = V(n) + V(n-1)
		QMPYL  	ACC,XT,*XAR7				; ACC = (K1/2)*[V(n) + V(n-1)] Q29*Q28(64-bit result in Q57) ACC in Q25
		LSL		ACC,#3						; shift into Q28												
		ADDL 	ACC,@FILT_BIQUAD_DBUFF:x:+6	; XAR4 points to W(n-1); ACC = W(n-1) + (K1/2)*[V(n) + V(n-1)]									   
		MOVL	@FILT_BIQUAD_DBUFF:x:+4,ACC	; save W(n)
			
; Calculate Low Pass Term Y(n)
;	Y(n) = Y(n-1) + (K1/2)*[W(n) + W(n-1)]			
 		ADDL	ACC,@FILT_BIQUAD_DBUFF:x:+6	; ACC = W(n) + W(n-1) Q28						 
		MOVL	@FILT_BIQUAD_temp2:x:,ACC	; 
		MOVL 	XT,@FILT_BIQUAD_temp2:x:	; XT = W(n) + W(n-1)
		QMPYL  	ACC,XT,*XAR7				; ACC = (K1/2)*[W(n) + W(n-1)] Q29*Q28(64-bit result in Q57) ACC in Q25
		LSL		ACC,#3						; shift into Q28												
		ADDL 	ACC,@FILT_BIQUAD_DBUFF:x:+10; XAR4 points to Y(n-1); ACC = Y(n-1) + (K1/2)*[W(n) + W(n-1)]									   
		MOVL	@FILT_BIQUAD_DBUFF:x:+8,ACC	; save Y(n)												   							   							   										   							   							   
		
		;move result to Uout as a Q15
		LSL		ACC,#3
		MOV		*XAR4,AH

	.endif ; !NET_DEBUG

	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
		MOV 	ACC,*XAR3			; mov In directly to Out
		MOV		*XAR4, AL			;  i.e. "In" to "Out" bypass
	.endif ; NET_DEBUG

				.endm


;============================================================================
;	BOXCAR_AVG  Macro module - Box Car averager (filter)
;============================================================================
;			______________________
;			|	  BOXCAR_AVG	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| In			  Out |-->
;			|_____________________|
;
;		In, Out: pointers to Signal Nets
;
; Description:
; ------------
; Averaging Filter function via Box Car method
;
; Revision History:
;-------------------------------------------------------------------------------
; Date		| Author	| Description
;-------------------------------------------------------------------------------
; 01/20/04	| Zendzian	| Original
; 06/06/04	| DAF		| Modified for Signal Net interface & converted to Macro
; ______________________________________________________________________________
;============================
BOXCAR_AVG_INIT	.macro x
;============================
; Constant Definitions
BCA_BUFF_SIZE		.set 	16			; # elements in the box car window
BCA_SHIFT			.set 	4			; shift value for divide

; Variable Declarations
_BOXCAR_AVG_In:x:		.usect "BCA_data",2,1,1		; Input Terminal 1
_BOXCAR_AVG_Out:x:		.usect "BCA_data",2 		; Output Terminal 1
BCA_BuffPtr:x:			.usect "BCA_data",2			; Pointer to current element
BOXCAR_AVG_BUFF:x:		.usect "BCA_data",BCA_BUFF_SIZE
BCA_Temp:x:				.usect "BCA_data",2
BCA_Cntr:x:				.usect "BCA_data",1

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
						.def 	_BOXCAR_AVG_In:x:
						.def 	_BOXCAR_AVG_Out:x:

		; set terminals to point to ZeroNet
			MOVL	XAR2, #_ZeroNet
			MOVW	DP, #_BOXCAR_AVG_In:x:
			MOVL	@_BOXCAR_AVG_In:x:, XAR2
			MOVL	XAR2, #DummyNet
			MOVL	@_BOXCAR_AVG_Out:x:, XAR2

		; Initialize the buffer pointer to the begining & clear counter
			MOVL	XAR7, #BOXCAR_AVG_BUFF:x:
			MOVL	@BCA_BuffPtr:x:, XAR7
			MOV		@BCA_Cntr:x:, #0

		; Zero the Box car Data Buffer
			MOVL 	XAR2,#BOXCAR_AVG_BUFF:x:
			RPT		#(BCA_BUFF_SIZE-1)
			||MOV	*XAR2++, #0

					.endm

;========================
BOXCAR_AVG		.macro x
;========================
		MOVW	DP, #_BOXCAR_AVG_In:x:
		MOVL 	XAR3,@_BOXCAR_AVG_In:x:		; Net pointer to In (XAR3)
		MOVL 	XAR4,@_BOXCAR_AVG_Out:x:	; Net pointer to Out (XAR4)

	.if(!NET_DEBUG) ; i.e. normal operation

; Update Buffer Pointer
		MOVL	ACC, @BCA_BuffPtr:x:
		ADD		ACC, @BCA_Cntr:x:			; ACC = BuffPtr + Cntr
		MOVL	@BCA_Temp:x:, ACC
		MOVL	XAR7, @BCA_Temp:x:			; XAR7 points to next element

; Update Counter			
		MOV		ACC,@BCA_Cntr:x:
		ADD		ACC,#1
		AND		ACC,#(BCA_BUFF_SIZE-1)	; Modulo wrap-around
		MOV		@BCA_Cntr:x:,ACC

; Load the buffers with the A/D results						
		MOV 	ACC, *XAR3					; Fetch "In" value from Net		
		MOV		*XAR7,AL					; Store it in the buffer						
		
; Execute Box Car Average
		ZAPA							; Clear ACC and P
		MOVL	XAR7,#BOXCAR_AVG_BUFF:x:
		RPT 	#(BCA_BUFF_SIZE-1)
		||ADD 	ACC,*XAR7++				; sum all the values in the buffer
		SFR		ACC,#BCA_SHIFT			; divide by number of buffer values
		MOV 	*XAR4,AL				; Output average value to Net				

	.endif ; !NET_DEBUG

	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
		MOV 	ACC,*XAR3			; mov In directly to Out
		MOV		*XAR4, AL			;  i.e. "In" to "Out" bypass
	.endif ; NET_DEBUG

				.endm
	



;============================================================================
;	EMA Macro module - Exponential moving average (filter)
;============================================================================
;			______________________
;			|	  EMA        	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| In			  Out |-->
;			|_____________________|
;
;		In, Out: pointers to Signal Nets
;
; Description:
; ------------
; Averaging Filter function via exponential moving average
; EMA(n) = (Data(n) - EMA(n-1))*MULTIPLER + EMA(n-1);
; Revision History:
;-------------------------------------------------------------------------------
; Date		| Author	| Description
;-------------------------------------------------------------------------------
; 08/19/05	| KAG		| Created new module 
; ______________________________________________________________________________
;============================
EM_AVG_INIT	.macro x
;============================
; Constant Definitions
EMA_PERIOD			.set 	16			 		 ; Set period to EMA
;Multiplier coeff used in equation: Q31
MULTIPLIER          .set    07fffh/(1+EMA_PERIOD) 


; Variable Declarations
_EMA_In:x:		.usect "BCA_data",2,1,1		; Input Terminal 1
_EMA_Out:x:		.usect "BCA_data",2 		; Output Terminal 1

EMA_Avg:x:		.usect "BCA_data",1			; Exponential mov avg store
EMA_Temp:x:		.usect "BCA_data",1 		; Temp var
EMA_Mult:x: 	.usect "BCA_data",1 		; Multipler


;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
				.def 	_EMA_In:x:
				.def 	_EMA_Out:x:

		; set terminals to point to ZeroNet
		MOVL	XAR2, #_ZeroNet
		MOVW	DP, #_EMA_In:x:
		MOVL	@_EMA_In:x:, XAR2
		MOVL	XAR2, #DummyNet
		MOVL	@_EMA_Out:x:, XAR2

		; Initialize the buffer pointer to the begining & clear counter
		MOV		@EMA_Avg:x:, #0
		MOV		@EMA_Mult:x:, #MULTIPLIER	; Store multipler

					.endm

; EMA(n) = (Data(n) - EMA(n-1))*MULTIPLER + EMA(n-1);
;========================
EM_AVG		.macro x
;========================
		MOVW	DP, #_EMA_In:x:
		MOVL 	XAR3,@_EMA_In:x:	; Net pointer to In  (XAR3)
		MOVL 	XAR4,@_EMA_Out:x:	; Net pointer to Out (XAR4)
		MOVL	XAR7,#EMA_Temp:x:

	.if(!NET_DEBUG) ; i.e. normal operation

; Load the buffers with the input					
		MOV 	ACC, *XAR3					; Fetch "In" value from Net		
		SUB	    ACC,@EMA_Avg:x:				; Compute the Data - EMA_Avg term

		MOV  	*XAR7,ACC					; Store difference in EMA_temp
		
		MOV 	T,@EMA_Mult:x:				; T = Multipler, Q15
		MPY     ACC, T, *XAR7				; Compute the product (diff)*MULTIPLIER
		
		ADD		ACC, @EMA_Avg:x:<<16		; Add the prev EMA to the product
		MOVH	*XAR4, ACC					; Store output to net.
		
		MOVL	XAR7,#EMA_Avg:x:			; Point XAR7 to EMA_Avg
		MOVH	*XAR7, ACC             		; Store new EMA in EMA_Avg
		

	.endif ; !NET_DEBUG

	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
		MOV 	ACC,*XAR3			; mov In directly to Out
		MOV		*XAR4, AL			;  i.e. "In" to "Out" bypass
	.endif ; NET_DEBUG

				.endm
	

;FILE_TAG: .\lib\dpslib280x\include\RectifierMiscMacro.inc 

;==================================================================================
;	SLEW_LIMIT Macro module - 2 Pole / 2 Zero
;==================================================================================
;			______________________
;			|	   SLEW_LIMIT	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| In			   	  |
;		 	|	 			  Out |-->
;		 -->| Incr		  		  |
;			|_____________________|
;
;			In, Incr, Out: pointers to Signal Nets
;
; Description:
; ------------
; Function to control slewrate. 
;
; Change History:
;-------------------------------------------------------------------------------
; Date		| Description
;-------------------------------------------------------------------------------
; 01/20/04	| Original
; 05/05/04	| Modified for Signal Net interface & converted to Macro
; 06/27/06  | Fixed bug reported against v1.0 re. roll overs.
; ______________________________________________________________________________

;===============================================================================
SLEW_LIMIT_INIT	.macro x
;=======================
; Variable Definitions
_SLEW_LIMIT_In:x:	.usect "SL_data",2,1,1		; Input Terminal 1
_SLEW_LIMIT_Incr:x:	.usect "SL_data",2 			; Input Terminal 2
_SLEW_LIMIT_Out:x:	.usect "SL_data",2 			; Output Terminal


;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_SLEW_LIMIT_In:x:				
					.def 	_SLEW_LIMIT_Incr:x:				
					.def 	_SLEW_LIMIT_Out:x:				

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_SLEW_LIMIT_In:x:
			MOVL	@_SLEW_LIMIT_In:x:, XAR2
			MOVL	@_SLEW_LIMIT_Incr:x:, XAR2
			MOVL	@_SLEW_LIMIT_Out:x:, XAR2

				.endm

;=======================
SLEW_LIMIT		.macro x
;=======================

	.if(!NET_DEBUG) ; i.e. normal operation
			MOVW	DP, #_SLEW_LIMIT_In:x:
			MOVL 	XAR4, @_SLEW_LIMIT_In:x:	; Net pointer to In (XAR4)
			MOVL 	XAR5, @_SLEW_LIMIT_Incr:x:	; Net pointer to Incr (XAR5)
			MOVL 	XAR6, @_SLEW_LIMIT_Out:x:	; Net pointer to Out (XAR6)

			MOV		ACC, *XAR4<<16			; load the setpoint
			SUB		ACC, *XAR6<<16			; compare with the latest output command
			B		SS_DONE? ,EQ			; if EQ, setpoint = previous output already.  Just exit.
			SETC	TC						; Going to use the TC bit for positive slewing.
			B		LEAVE_BIT?, LT
			CLRC	TC						; ACC was negative, clear the TC bit.
LEAVE_BIT?
			ABS		ACC						; Asking for this much change.
			MIN		AH, *XAR5				; Limit change to Incr.
			B		INCREASE_CMD?, NTC		; if difference was positive, slew command up
REDUCE_CMD?									; else diff is negative, slew command down
			NEG		ACC						; for negative slewing just invert amount to add. 
INCREASE_CMD?
			ADD		ACC, *XAR6<<16			; Add in limited, sign correct change in value
			MOV		*XAR6, AH				; Store to output.
SS_DONE?

	.endif ; !NET_DEBUG

	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
			MOV 	ACC,*XAR4			; mov Ref directly to Out
			MOV		*XAR6, AL			;  i.e. "In" to "Out" bypass
	.endif ; NET_DEBUG

				.endm

;============================================================================
;	AC_LINE_RECT  Macro module - Absolute value function
;============================================================================
;			______________________
;			|	  AC_LINE_RECT	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| In			  Out |-->
;			|_____________________|
;
;			In, Out: pointers to Signal Nets
;
; Description:
; ------------
; Rectifies input AC line
;
; Change History:
;-------------------------------------------------------------------------------
; Date		| Author	| Description
;-------------------------------------------------------------------------------
; 01/20/04	| Zendzian	| Original
; 05/05/04	| DAF		| Modified for Signal Net interface & converted to Macro
; ______________________________________________________________________________
;===============================================================================
AC_LINE_RECT_INIT	.macro x
;===========================
; Variable Definitions
_AC_LINE_RECT_In:x:		.usect "ALR_data",2,1,1		; Input Terminal 1
_AC_LINE_RECT_Out:x:	.usect "ALR_data",2 		; Output Terminal 1

;Publish Terminal Pointers for access from the C environment 
;======================================================================
			.def 	_AC_LINE_RECT_In:x:				
			.def 	_AC_LINE_RECT_Out:x:				

		; actual macro code starts here
			MOVW	DP, #_AC_LINE_RECT_In:x:
			MOV		@_AC_LINE_RECT_In:x:, #0
			MOV		@(_AC_LINE_RECT_In:x:+1), #0
			MOV		@_AC_LINE_RECT_Out:x:, #0
			MOV		@(_AC_LINE_RECT_Out:x:+1), #0
					.endm

;=======================
AC_LINE_RECT	.macro x
;=======================
			MOVW	DP, #_AC_LINE_RECT_In:x:
			MOVL 	XAR4,@_AC_LINE_RECT_In:x:		; Net pointer to In (XAR4)
			MOVL 	XAR5,@_AC_LINE_RECT_Out:x:		; Net pointer to Out (XAR5)


	.if(!NET_DEBUG) ; i.e. normal operation
			MOV 	ACC,*XAR4<<16					;left justify inside ACC
			
		; Rectify the filtered AC Line sample by taking Absolute Value														
			ABS 	ACC
			MOV 	*XAR5,AH						;Output ABS value			
	.endif ; !NET_DEBUG


	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
			MOV 	ACC,*XAR4			; mov Ref directly to Out
			MOV		*XAR5, AL			;  i.e. "In" to "Out" bypass
	.endif ; NET_DEBUG

				.endm



;============================================================================
;	PFC_ICMD  Macro module - PFC Current Command
;============================================================================
;			______________________
;			|	   PFC_ICMD	  	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| V1			  	  |
;		 -->| V2			  Out |-->
;		 -->| Vac			  	  |
;			|_____________________|
;
;			V1, V2, Vac, Out: pointers to Signal Nets
;
; Description:
; ------------
; Calclulates the PFC current loop command according to:
;
;	Out = V1*V2*Vac*Km
;
;	Where:	V1 is the output of the Voltage controller Q15
;			V2 is the inverse of the Average AC line, squared
;			Vac is the instantaneous value of the AC line
;			Km is a constant = Vmax/Vmin
;
; Revision History:
;-------------------------------------------------------------------------------
; Date		| Author	| Description
;-------------------------------------------------------------------------------
; 01/26/04	| DSZ		| Original
; 06/06/04	| DAF		| Modified for Signal Net interface & converted to Macro
; 03/15/05	| DSZ		| Verification
; 06/27/06  | KAG       | Rescaled and fixed some of the math with PFC proto board.
; ______________________________________________________________________________
;============================
PFC_ICMD_INIT		.macro x
;============================
; Constant Definitions
VMAX_OVER_VMIN		.set  	0x3000			; 36V/12V = 3.000 in 4.12  
MAX_CURRENT_CMDH	.set 	0x0FFF	 		; MAX Q27
MAX_CURRENT_CMDL	.set	0xFFFF
MIN_CURRENT_CMDH	.set 	0x0000	 		; MIN Q27
MIN_CURRENT_CMDL	.set	0x0000

; Variable Declarations
_PFC_ICMD_V1:x:			.usect "PIC_data",2,1,1		; Input Terminal 1
_PFC_ICMD_V2:x:			.usect "PIC_data",2 		; Input Terminal 2
_PFC_ICMD_Vac:x:		.usect "PIC_data",2 		; Input Terminal 3
_PFC_ICMD_Out:x:		.usect "PIC_data",2 		; Output Terminal 1
MaxCurrentCmd:x:		.usect "PIC_data",2			; "Local" memory Long
MinCurrentCmd:x:		.usect "PIC_data",2			; "Local" memory Long
VmaxOverVmin:x:			.usect "PIC_data",1			; "Local" memory

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_PFC_ICMD_V1:x:
					.def 	_PFC_ICMD_V2:x:
					.def 	_PFC_ICMD_Vac:x:
					.def 	_PFC_ICMD_Out:x:

		; actual macro code starts here
			MOVL	XAR2, #_ZeroNet
			MOVW	DP, #_PFC_ICMD_V1:x:
			MOVL	@_PFC_ICMD_V1:x:, XAR2
			MOVL	@_PFC_ICMD_V2:x:, XAR2
			MOVL	@_PFC_ICMD_Vac:x:, XAR2
			MOVL	@_PFC_ICMD_Out:x:, XAR2

			MOV		@VmaxOverVmin:x:,  #VMAX_OVER_VMIN

			MOV		@MaxCurrentCmd:x:,   #MAX_CURRENT_CMDL
			MOV		@MaxCurrentCmd:x:+1, #MAX_CURRENT_CMDH

			MOV		@MinCurrentCmd:x:,   #MIN_CURRENT_CMDL
			MOV		@MinCurrentCmd:x:+1, #MIN_CURRENT_CMDH

					.endm

;=======================
PFC_ICMD		.macro x
;=======================
			MOVW	DP, #_PFC_ICMD_V1:x:
			MOVL 	XAR3,@_PFC_ICMD_V1:x:		; Net pointer to V1 (XAR3)
			MOVL 	XAR4,@_PFC_ICMD_V2:x:		; Net pointer to V2 (XAR4)
			MOVL 	XAR5,@_PFC_ICMD_Vac:x:		; Net pointer to Vac (XAR5)
			MOVL 	XAR6,@_PFC_ICMD_Out:x:		; Net pointer to Out (XAR6)

	.if(!NET_DEBUG) ; i.e. normal operation

			MOV 	T,*XAR3				; T = V1
			MPY		ACC,T,*XAR4			; ACC = V1*V2  Q15*Q15=Q30
			NORM 	ACC,*				; ACC now in Q31
			MOV		*XAR6,AH			; temporarily save to Out as Q15
			MOV		T,*XAR6				;
		
			MPY		ACC,T,*XAR5			; ACC = V1*V2*Vac  Q15*Q15=Q30
			NORM 	ACC,*				; ACC now in Q31
			MOV		*XAR6, AH			; temporarily save as Q15
			MOV		T, *XAR6
			MPY		ACC,T,@VmaxOverVmin:x:	; Q27 ACC = [V1*V2*Vac]*Km Q15*Q12
		
		; Saturate the result [0,1]
			MINL 	ACC,@MaxCurrentCmd:x:					
			MAXL 	ACC,@MinCurrentCmd:x:
			LSL		ACC,#4				; Convert to Q31	
			MOV		*XAR6,AH			; Save result as a Q15

	.endif ; !NET_DEBUG

	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
			MOV 	ACC,*XAR3			; mov V1 directly to Out
			MOV		*XAR6, AL			;  i.e. "V1" to "Out" bypass
	.endif ; NET_DEBUG

				.endm

;============================================================================
;	INV_SQR  Macro module - Inverse Squared function
;============================================================================
;			______________________
;			|	 	INV_SQR	      |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| In			  Out |-->
;			|_____________________|
;
;			In, Out: pointers to Signal Nets
;
; Description:
; ------------
; Performs Inverse Squared function.  The Average AC line value can be derived
; upstream by a filtering and Rectification function, e.g. FILT_BIQUAD & 
; AC_LINE_RECT respectively.
;
; Revision History:
;-------------------------------------------------------------------------------
; Date		| Author	| Description
;-------------------------------------------------------------------------------
; 01/26/04	| DSZ		| Original
; 04/29/04	| DAF		| Modified for Signal Net interface & converted to Macro
; 03/16/06  | KAG       | Fixed endian convention and some other errors in 
;           |           | INV_AVG
; ______________________________________________________________________________
;===============================================================================
INV_SQR_INIT		.macro x
;===========================
; Constant Definitions
VMIN_OVER_VMAXH		.set 	0x0000		; 12V/36V Long in Q15 format
VMIN_OVER_VMAXL		.set	0x2aaa
MIN_AVG_ACLINE		.set	0x2aaa		; Q15 format, 51V full scale
PI_OVER2_Q14		.set	0x6487

; Variable Declarations
_INV_SQR_In:x:		.usect "ISQR_data",2,1,1		; Input Terminal 1
_INV_SQR_Out:x:		.usect "ISQR_data",2 			; Output Terminal 1
INV_LongTemp:x:		.usect "ISQR_data",2 			; "local" memory - Long
VminOverVmax:x:		.usect "ISQR_data",2			; "Local" memory - Long
INV_SQR_Temp:x:		.usect "ISQR_data",1 			; "Local" memory

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_INV_SQR_In:x:		
					.def 	_INV_SQR_Out:x:

			MOVW	DP, #_INV_SQR_In:x:
			MOV		@_INV_SQR_In:x:, #0
			MOV		@(_INV_SQR_In:x:+1), #0
			MOV		@_INV_SQR_Out:x:, #0
			MOV		@(_INV_SQR_Out:x:+1), #0

			MOV		@VminOverVmax:x:,   #VMIN_OVER_VMAXL
			MOV		@VminOverVmax:x:+1, #VMIN_OVER_VMAXH

					.endm

;=======================
INV_SQR			.macro x
;=======================
		MOVW	DP, #_INV_SQR_In:x:
		MOVL 	XAR3,@_INV_SQR_In:x:			; Net pointer to In (XAR3)
		MOVL 	XAR4,@_INV_SQR_Out:x:			; Net pointer to Out (XAR4)

	.if(!NET_DEBUG) ; i.e. normal operation
		
	; Clamp the minimum Average AC Line to allow the normalization to work
	; at very low inputs. i.e. using a Variac during debug.
		MOV 	ACC,*XAR3					; ACC = "In"
		MOV		@INV_SQR_Temp:x:, AL
		SUB 		ACC,#MIN_AVG_ACLINE
		B 		LINE_INRANGE:x:,GEQ			; if ACC>=0 don't clamp
		MOV		ACC,#MIN_AVG_ACLINE			; if ACC<0 clamp to a minimum
		MOV		@INV_SQR_Temp:x:,AL			; temporarily store it
								
LINE_INRANGE:x::		
	; Renormalize the Average AC Line measurement to it's own max by multiplying by pi/2
		MOV		ACC,@INV_SQR_Temp:x:<<16				; reload the clamped value
		MPY		ACC,@INV_SQR_Temp:x:,#PI_OVER2_Q14	; Q15*Q14 = Q29
		LSL		ACC,#2								; shift into Q15
		MOV		@INV_SQR_Temp:x:,AH					; temporarily store it
		
	; Calculate 1/In^2 --> do divide
	; Numerator of 1/period is treated as a Q31 value, result of this
	; division is in Q16(=Q31/Q15)
  		CLRC    TC						; Clear TC flag, used as sign flag	
		MOV		ACC,#07FFFh				; AH = 0, AL = high 16-bits of Numerator
  		RPT     #15		
  		||SUBCU ACC,@INV_SQR_Temp:x:	; Conditional subtract with period_cntr(denominator)	
		MOV     @INV_LongTemp:x:+1,AL	; Store higher 16-bit of the result				
		MOV		AL,#0FFFFh				; AL = low 16-bits of Numerator(32-bit)
  		RPT     #15	
  		||SUBCU ACC,@INV_SQR_Temp:x:	; Conditional subtract with period_cntr(denominator)
  		MOV     ACC,@AL << 16			; AH = low 16-bits of the result, AL = 0	
		MOV     @INV_LongTemp:x:,AH		; Store lower 16-bit of the result		
			
	; Renormalize the Inverse Avg AC Line measurement to it's own max by multiplying by Vmin/Vmax
		MOVL	XT,@INV_LongTemp:x:		; Multiply Inverse of In value by Vmin/Vmax in Q15
		IMPYL	ACC,XT,@VminOverVmax:x:	; Q15*Q15 = Q30

	; Now Square 1/In		
		MOVL	@INV_LongTemp:x:,ACC	; inv_avgAC now has Q30 result
		MOVL	XT,@INV_LongTemp:x:
		QMPYL	ACC,XT,@INV_LongTemp:x:	; square inv_avgAC, ACC has Q29
		NORM 	ACC,*
		NORM	ACC,*
		MOV	*XAR4,AH				; save as Q15 to output Net		
	.endif ; !NET_DEBUG


	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
			MOV 	ACC,*XAR3			; mov In directly to Out
			MOV		*XAR4, AL			;  i.e. "In" to "Out" bypass
	.endif ; NET_DEBUG

				.endm

;FILE_TAG: .\lib\dpslib280x\include\WaveGenMacro.inc 

;============================================================================
;	SINGEN_1CH Macro module - Single channel Sine generator
;============================================================================

;			______________________
;			|	  SINGEN_1CH  	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| Gain			  	  |
;		 -->| Offset		  Out |-->
;		 -->| Freq			  	  |
;			|_____________________|
;
;			Gain, Offset, Freq, Out: pointers to Signal Nets
;
; Description:
; ------------
; This file contains source code for single a channel SINE generator module
; (Using Direct Table look-up)
;
; Change History:
;===============================================================================
SINGEN_1CH_INIT	.macro x
;=======================
; Refer to sine table
                		.ref    SINTAB_360

; Constant Definitions
SIN_FREQ_MAX			.set   	0x1000				; Q15 

; Variable Definitions
_SINGEN_1CH_Gain:x:		.usect "SINGEN_data",2,1,1	; Input Terminal 1
_SINGEN_1CH_Offset:x:	.usect "SINGEN_data",2 		; Input Terminal 2
_SINGEN_1CH_Freq:x:		.usect "SINGEN_data",2 		; Input Terminal 3
_SINGEN_1CH_Out:x:		.usect "SINGEN_data",2 		; Output Terminal
SINGEN_1CH_Alpha:x:		.usect "SINGEN_data",1 		; Local Memory (history)
SINGEN_1CH_Fmax:x:		.usect "SINGEN_data",1 		; Local Memory


;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_SINGEN_1CH_Gain:x:				
					.def 	_SINGEN_1CH_Offset:x:
					.def 	_SINGEN_1CH_Freq:x:
					.def 	_SINGEN_1CH_Out:x:

		; actual macro code starts here
			MOVW	DP, #_SINGEN_1CH_Gain:x:
			MOV		@_SINGEN_1CH_Gain:x:, #0
			MOV		@(_SINGEN_1CH_Gain:x:+1), #0
			MOV		@_SINGEN_1CH_Offset:x:, #0
			MOV		@(_SINGEN_1CH_Offset:x:+1), #0
			MOV		@_SINGEN_1CH_Freq:x:, #0
			MOV		@(_SINGEN_1CH_Freq:x:+1), #0
			MOV		@_SINGEN_1CH_Out:x:, #0
			MOV		@(_SINGEN_1CH_Out:x:+1), #0
			MOV		@SINGEN_1CH_Fmax:x:, #SIN_FREQ_MAX
			MOV		@SINGEN_1CH_Alpha:x:, #0
				.endm

;=======================
SINGEN_1CH		.macro x
;=======================
			MOVW	DP, #_SINGEN_1CH_Gain:x:
			MOVL 	XAR2,@_SINGEN_1CH_Gain:x:	; Net pointer to Gain (XAR2)
			MOVL 	XAR3,@_SINGEN_1CH_Offset:x:	; Net pointer to Offset (XAR3)
			MOVL 	XAR4,@_SINGEN_1CH_Freq:x:	; Net pointer to Freq (XAR4)
			MOVL 	XAR5,@_SINGEN_1CH_Out:x:	; Net pointer to Out (XAR5)

	.if(!NET_DEBUG) ; i.e. normal operation

            SETC    SXM,OVM
                            
; Obtain the step value in pro-rata with the freq input         
            MOV     T,@SINGEN_1CH_Fmax:x:	; T = step_max (i.e. Freq max)
            MPY     ACC,T,*XAR4		   		; ACC = Freq*step_max
            MOVH    AL,ACC<<1           
            
; Increment the angle "alpha" by step value             
            ADD     AL,@SINGEN_1CH_Alpha:x:	; AL=(freq*step_max)+alpha  (Q0)
            MOV     @SINGEN_1CH_Alpha:x:,AL	; alpha=alpha+step

; Obtain the SIN of the angle "X=alpha" using direct Look-up Table            
            MOVL    XAR6,#SINTAB_360	;XAR5->SINTAB_360
            MOVB    XAR0,#0         
            MOVB    AR0,AL.MSB      	; AR0=indice (alpha/2^8)
            MOV     T,*+XAR6[AR0]   	; T=Y=*(SINTAB_360 + index)

; Scale the SIN output with the gain and add offset           
            MPY     ACC,T,*XAR2			; ACC=Y=SineValue * Gain
            LSL     ACC,#1          	; ACC=Y (Q31)
            ADD     ACC,*XAR3<<16 		; ACC=Y + Offset
            MOV     *XAR5,AH	    	; Out=Y*Gain+Offset
        	CLRC 	OVM

	.endif ; !NET_DEBUG


	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
			MOV 	ACC,*XAR2			; mov Gain directly to Out
			MOV		*XAR5, AL			;  i.e. "Gain" to "Out" bypass
	.endif ; NET_DEBUG


				.endm

;============================================================================
;	RAMPGEN_1CH Macro module - Single channel Ramp generator
;============================================================================

;			______________________
;			|	  RAMPGEN_1CH  	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| Gain			  	  |
;		 -->| Offset		  Out |-->
;		 -->| Freq			  	  |
;			|_____________________|
;
;			Gain, Offset, Freq, Out: pointers to Signal Nets
;
; Description:
; ------------
; This file contains source code for single a channel SINE generator module
; (Using Direct Table look-up)
;
; Change History:
;-------------------------------------------------------------------------------
; Date		| Author	| Description
;-------------------------------------------------------------------------------
; 12/27/01	| TI Houst. | Original
; 05/05/04	| DAF		| Modified for Signal Net interface & converted to Macro
; 10/28/04	| DAF		| Modified .usect names
; ______________________________________________________________________________
;===============================================================================
RAMPGEN_1CH_INIT	.macro x
;=======================

; Constant Definitions
RMP_FREQ_MAX			.set   	0x1000				; Q15 

; Variable Definitions
_RAMPGEN_1CH_Gain:x:	.usect "SINGEN_data",2,1,1	; Input Terminal 1
_RAMPGEN_1CH_Offset:x:	.usect "SINGEN_data",2 		; Input Terminal 2
_RAMPGEN_1CH_Freq:x:	.usect "SINGEN_data",2 		; Input Terminal 3
_RAMPGEN_1CH_Out:x:		.usect "SINGEN_data",2 		; Output Terminal
RAMPGEN_1CH_Alpha:x:	.usect "SINGEN_data",1 		; Local Memory (history)
RAMPGEN_1CH_Fmax:x:		.usect "SINGEN_data",1 		; Local Memory


;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_RAMPGEN_1CH_Gain:x:				
					.def 	_RAMPGEN_1CH_Offset:x:
					.def 	_RAMPGEN_1CH_Freq:x:
					.def 	_RAMPGEN_1CH_Out:x:

		; actual macro code starts here
			MOVW	DP, #_RAMPGEN_1CH_Gain:x:
			MOV		@_RAMPGEN_1CH_Gain:x:, #0
			MOV		@(_RAMPGEN_1CH_Gain:x:+1), #0
			MOV		@_RAMPGEN_1CH_Offset:x:, #0
			MOV		@(_RAMPGEN_1CH_Offset:x:+1), #0
			MOV		@_RAMPGEN_1CH_Freq:x:, #0
			MOV		@(_RAMPGEN_1CH_Freq:x:+1), #0
			MOV		@_RAMPGEN_1CH_Out:x:, #0
			MOV		@(_RAMPGEN_1CH_Out:x:+1), #0
			MOV		@RAMPGEN_1CH_Fmax:x:, #RMP_FREQ_MAX
			MOV		@RAMPGEN_1CH_Alpha:x:, #0
				.endm

;=======================
RAMPGEN_1CH		.macro x
;=======================
			MOVW	DP, #_RAMPGEN_1CH_Gain:x:
			MOVL 	XAR2,@_RAMPGEN_1CH_Gain:x:	; Net pointer to Gain (XAR2)
			MOVL 	XAR3,@_RAMPGEN_1CH_Offset:x:	; Net pointer to Offset (XAR3)
			MOVL 	XAR4,@_RAMPGEN_1CH_Freq:x:	; Net pointer to Freq (XAR4)
			MOVL 	XAR5,@_RAMPGEN_1CH_Out:x:	; Net pointer to Out (XAR5)

	.if(!NET_DEBUG) ; i.e. normal operation

            SETC    SXM,OVM
                            
; Obtain the step value in pro-rata with the freq input         
            MOV     T,@RAMPGEN_1CH_Fmax:x:	; T = step_max (i.e. Freq max)
            MPY     ACC,T,*XAR4		   		; ACC = Freq*step_max
            MOVH    AL,ACC<<1           
            
; Increment the angle "alpha" by step value             
            ADD     AL,@RAMPGEN_1CH_Alpha:x:	; AL=(freq*step_max)+alpha  (Q0)
            MOV     @RAMPGEN_1CH_Alpha:x:,AL	; alpha=alpha+step
            MOV     T,AL

; Scale the SIN output with the gain and add offset           
            MPY     ACC,T,*XAR2			; ACC=Y=Alpha * Gain
            LSL     ACC,#1          	; ACC=Y (Q31)
            ADD     ACC,*XAR3<<16 		; ACC=Y + Offset
            MOV     *XAR5,AH	    	; Out=Y*Gain+Offset
        	CLRC 	OVM

	.endif ; !NET_DEBUG


	; Used for debug only - checks module connectivity.
	.if(NET_DEBUG)
			MOV 	ACC,*XAR2			; mov Gain directly to Out
			MOV		*XAR5, AL			;  i.e. "Gain" to "Out" bypass
	.endif ; NET_DEBUG


				.endm


;FILE_TAG: .\lib\drvlib280x\include\ADC_DriverMacro.inc 
		
;**********************************************************************************
; Configuration Constant Definitions
;**********************************************************************************
RST_SEQ1 		.set    0x4000
RST_SEQ2		.set 	0x0040
RST_SEQ1_2		.set 	0x4040
START_SEQ1 		.set    0x2000		

;============================================================================
;	ADC2CH_DRV  Macro module
;============================================================================
;			______________________
;			|	   ADC2CH_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 <--| Rslt[0:1]	   ADCINx |<--
;		 	|		  	   ADCINy |<--
;			|_____________________|
;
;	Rslt[0:1] is a pointer to a Signal Net Bus (2 consecutively addressed Nets)
;
; Description:
; ------------
; ADC peripheral Driver interface.
; Assumes address of 1st Net Bus Address is in Rslt
;
;==================================================================================
ADC2CH_DRV_INIT	.macro
;=======================
; Variable Definitions
_ADC2CH_Rslt		.usect "ADC2CH_DRV_Data",2,1,1		; Output Terminal 1


;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_ADC2CH_Rslt

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #DummyNet
			MOVW	DP, #_ADC2CH_Rslt
			MOVL	@_ADC2CH_Rslt, XAR2
					.endm

;======================
ADC2CH_DRV		.macro
;======================
; uses PF0 (0WS mem)
			MOVW	DP, #_ADC2CH_Rslt
			MOVL 	XAR4,@_ADC2CH_Rslt		; XAR4: pointer to Net Bus

			MOVW	DP,#ADCPF0R0>>6
			MOVL 	XAR2,#ADCPF0R0			; XAR2: pointer to ADC buffer regs

; Read Result0 (1st conversion)
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result1 (2nd conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Reset the sequencer 1
			MOVW 	DP,#ADCTRL2>>6
			MOV 	AL,@ADCTRL2
			OR 		AL,#RST_SEQ1
			MOV     @ADCTRL2,AL	
				.endm

;============================================================================
;	ADC2CH_BSEL_DRV  Macro module
;============================================================================
;			______________________
;			|	ADC2CH_BSEL_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 <--| Rslt[0:6]	   ADCINx |<--
;		 -->| BchSel 	   ADCINy |<--
;			|_____________________|
;
;	Rslt[0:6] is a pointer to a Signal Net Bus (7 consecutively addressed Nets)
;
; Description:
; ------------
; ADC peripheral Driver interface. Input channel ADCINx is fixed to Rslt[0].
; Input channel ADCINy is directed to one of locations Result[1:6] depending on
; value of BchSel.
; BchSel possible values are 1,2,3,..6
; Assumes address of 1st Net Bus Address is in Rslt
;
;==================================================================================
ADC2CH_BSEL_DRV_INIT	.macro
;=======================
; Variable Definitions
_ADC2CH_Rslt		.usect "ADC2CH_BSEL_DRV_Data",2,1,1	; Output Terminal 1
_ADC_BchSel			.usect "ADC2CH_BSEL_DRV_Data",2		; Input Terminal 2
BchSelActive		.usect "ADC2CH_BSEL_DRV_Data",1 		; Current ch selection for ADCINy

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_ADC2CH_Rslt
					.def	_ADC_BchSel

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #DummyNet
			MOVW	DP, #_ADC2CH_Rslt
			MOVL	@_ADC2CH_Rslt, XAR2
			MOVL	@_ADC_BchSel, XAR3
			MOV		@BchSelActive, #1
					.endm

;======================
ADC2CH_BSEL_DRV		.macro
;======================
; uses PF0 (0WS mem)
			MOVW	DP, #_ADC2CH_Rslt
			MOVL 	XAR4,@_ADC2CH_Rslt	; Net pointer for Rslt[0:6]	(XAR4)
			MOVL 	XAR3,@_ADC_BchSel	; Net pointer for BchSel	(XAR3)
			MOVZ	AR1, @BchSelActive	; load the current B channel selection
			MOV		AL, *XAR3			; get B ch selection from input
			MOV		@BchSelActive, AL	;   and store ready for next time

			MOVW	DP,#ADCPF0R0>>6
			MOVL 	XAR2,#ADCPF0R0		; XAR2: "local" pointer to ADC buffer regs

; Read Result0 (1st conversion)
			MOV 	ACC,*XAR2++<<3		; conv to Q15 format, Unipolar input
			MOV 	*XAR4,AL			; move to Rslt[0]

; Read Result1 (2nd conversion)		
		; Use <<3 if Q15 needed, else rely on BC Avg to scale
			;MOV 	ACC,*XAR2++<<3		; get next result (conv to Q15, Uni)
			MOV 	ACC,*XAR2++			; Let BC Avg shift by 3 (i.e. x8)
			MOV 	*+XAR4[AR1],AL		; move to Rslt[BchSelActive]

; Update Conv 2 Channel select and Reset the sequencer 1
			MOVW 	DP,#ADCTRL2>>6

			MOV		AL, @ADCCHSELSEQ1
			AND		ACC, #0x0F
			ADD		ACC, *XAR3<<4
			ADD		ACC, #0x070
			MOV		@ADCCHSELSEQ1, AL

			MOV 	AL,@ADCTRL2
			OR 		AL,#RST_SEQ1
			OR 		AL,#START_SEQ1		; un-comment if "manual" (SW) SOC
			MOV     @ADCTRL2,AL	
				.endm

;============================================================================
;	ADC6CONT_DRV  Macro module (uses ADC mirror regs in PF0)
;============================================================================
;			______________________
;			|	  ADC6CONT_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 <--| Rslt[0:5]	   ADCINu |<--
;		 	|		  	   ADCINv |<--
;		 	|		  	   ADCINw |<--
;		 	|		  	   ADCINx |<--
;		 	|		  	   ADCINy |<--
;		 	|		  	   ADCINz |<--
;			|_____________________|
;
;	Rslt[0:5] is a pointer to a Signal Net Bus (6 consecutively addressed Nets)
;
; Description:
; ------------
; ADC peripheral Driver interface.
; Assumes address of 1st Net Bus Address is in Rslt
;
;==========================
ADC6CONT_DRV_INIT	.macro
;==========================
; Variable Definitions
_ADC6CH_Rslt		.usect "ADC6CONT_DRV_Data",2,1,1		; Output Terminal 1

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_ADC6CH_Rslt

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #DummyNet
			MOVW	DP, #_ADC6CH_Rslt
			MOVL	@_ADC6CH_Rslt, XAR2
					.endm

;=========================
ADC6CONT_DRV	.macro
;=========================
; uses PF0 (0WS mem)
			MOVW	DP, #_ADC6CH_Rslt
			MOVL 	XAR0,@_ADC6CH_Rslt		; XAR0: pointer to Net Bus

			MOVW	DP,#ADCPF0R0>>6
			MOVL 	XAR1,#ADCPF0R0			; XAR1: pointer to ADC buffer regs

; Read Result0 (1st conversion)
			MOV 	ACC,*XAR1++<<3
			MOV 	*XAR0++,AL				; Q15 format, Unipolar input

; Read Result1 (2nd conversion)		
			MOV 	ACC,*XAR1++<<3
			MOV 	*XAR0++,AL				; Q15 format, Unipolar input

; Read Result2 (3rd conversion)		
			MOV 	ACC,*XAR1++<<3
			MOV 	*XAR0++,AL				; Q15 format, Unipolar input

; Read Result3 (4th conversion)		
			MOV 	ACC,*XAR1++<<3
			MOV 	*XAR0++,AL				; Q15 format, Unipolar input

; Read Result4 (5th conversion)		
			MOV 	ACC,*XAR1++<<3
			MOV 	*XAR0++,AL				; Q15 format, Unipolar input

; Read Result5 (6th conversion)		
			MOV 	ACC,*XAR1++<<3
			MOV 	*XAR0++,AL				; Q15 format, Unipolar input
				.endm

;============================================================================
;	ADC5CONT_DRV  Macro module (uses ADC mirror regs in PF0)
;============================================================================
;			______________________
;			|	  ADC5CONT_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 <--| Rslt[0:4]	   ADCINu |<--
;		 	|		  	   ADCINv |<--
;		 	|		  	   ADCINw |<--
;		 	|		  	   ADCINx |<--
;		 	|		  	   ADCINy |<--
;			|_____________________|
;
;	Rslt[0:4] is a pointer to a Signal Net Bus (5 consecutively addressed Nets)
;
; Description:
; ------------
; ADC peripheral Driver interface.
; Assumes address of 1st Net Bus Address is in Rslt
;
;==========================
ADC5CONT_DRV_INIT	.macro
;==========================
; Variable Definitions
_ADC5CH_Rslt		.usect "ADC5CH_CONT_DRV_Data",2,1,1		; Output Terminal 1

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_ADC5CH_Rslt

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #DummyNet
			MOVW	DP, #_ADC5CH_Rslt
			MOVL	@_ADC5CH_Rslt, XAR2
					.endm

;=========================
ADC5CONT_DRV	.macro
;=========================
; uses PF0 (0WS mem)
			MOVW	DP, #_ADC5CH_Rslt
			MOVL 	XAR4,@_ADC5CH_Rslt		; XAR4: pointer to Net Bus

			MOVW	DP,#ADCPF0R0>>6
			MOVL 	XAR2,#ADCPF0R0			; XAR2: pointer to ADC buffer regs

; Read Result0 (1st conversion)
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result1 (2nd conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result2 (3rd conversion) 			; AC Line Voltage (Note: Bipolar)
			MOV 	ACC,*XAR2++<<4			; Get value in acc with MSB in bit 15
			XOR		ACC,#8000h				; Convert to Q15, Bipolar input
			MOV 	*XAR4++,AL				; Q15 format, Bipolar input

; Read Result3 (4th conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result4 (5th conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input
				.endm

;============================================================================
;	ADC4CONT_DRV  Macro module (uses ADC mirror regs in PF0)
;============================================================================
;			______________________
;			|	  ADC4CONT_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 <--| Rslt[0:3]	   ADCINw |<--
;		 	|		  	   ADCINx |<--
;		 	|		  	   ADCINy |<--
;		 	|		  	   ADCINz |<--
;			|_____________________|
;
;	Rslt[0:3] is a pointer to a Signal Net Bus (4 consecutively addressed Nets)
;
; Description:
; ------------
; ADC peripheral Driver interface.
; Assumes address of 1st Net Bus Address is in Rslt
;
;==========================
ADC4CONT_DRV_INIT	.macro
;==========================
; Variable Definitions
_ADC4CH_Rslt		.usect "ADC4CH_CONT_DRV_Data",2,1,1		; Output Terminal 1

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_ADC4CH_Rslt

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #DummyNet
			MOVW	DP, #_ADC4CH_Rslt
			MOVL	@_ADC4CH_Rslt, XAR2
					.endm

;=========================
ADC4CONT_DRV	.macro		;8 ? cycles
;=========================
; uses PF0 (0WS mem)
			MOVW	DP, #_ADC4CH_Rslt
			MOVL 	XAR4,@_ADC4CH_Rslt		; XAR4: pointer to Net Bus

			MOVW	DP,#ADCPF0R0>>6
			MOVL 	XAR2,#ADCPF0R0			; XAR2: pointer to ADC buffer regs

; Read Result0 (1st conversion)
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result1 (2nd conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result2 (3rd conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result3 (4th conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input
				.endm


;============================================================================
;	ADC3CONT_DRV  Macro module (uses ADC mirror regs in PF0)
;============================================================================
;			______________________
;			|	  ADC3CONT_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 <--| Rslt[0:2]	   ADCINx |<--
;		 	|		  	   ADCINy |<--
;		 	|		  	   ADCINz |<--
;			|_____________________|
;
;	Rslt[0:2] is a pointer to a Signal Net Bus (3 consecutively addressed Nets)
;
; Description:
; ------------
; ADC peripheral Driver interface.
; Assumes address of 1st Net Bus Address is in Rslt
;
;==========================
ADC3CONT_DRV_INIT	.macro
;==========================
; Variable Definitions
_ADC3CH_Rslt		.usect "ADC3CH_CONT_DRV_Data",2,1,1		; Output Terminal 1

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_ADC3CH_Rslt

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #DummyNet
			MOVW	DP, #_ADC3CH_Rslt
			MOVL	@_ADC3CH_Rslt, XAR2
					.endm

;=========================
ADC3CONT_DRV	.macro		;8 ? cycles
;=========================
; uses PF0 (0WS mem)
			MOVW	DP, #_ADC3CH_Rslt
			MOVL 	XAR4,@_ADC3CH_Rslt		; XAR4: pointer to Net Bus

			MOVW	DP,#ADCPF0R0>>6
			MOVL 	XAR2,#ADCPF0R0			; XAR2: pointer to ADC buffer regs

; Read Result0 (1st conversion)
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result1 (2nd conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result2 (3rd conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

				.endm

;============================================================================
;	ADC2CONT_DRV  Macro module (uses ADC mirror regs in PF0)
;============================================================================
;			______________________
;			|	  ADC2CONT_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 <--| Rslt[0:1]	   ADCINx |<--
;		 	|		  	   ADCINy |<--
;			|_____________________|
;
;	Rslt[0:1] is a pointer to a Signal Net Bus (2 consecutively addressed Nets)
;
; Description:
; ------------
; ADC peripheral Driver interface.
; Assumes address of 1st Net Bus Address is in Rslt
;
;==========================
ADC2CONT_DRV_INIT	.macro
;==========================
; Variable Definitions
_ADC2CH_Rslt		.usect "ADC2CH_CONT_DRV_Data",2,1,1		; Output Terminal 1

;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_ADC2CH_Rslt

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #DummyNet
			MOVW	DP, #_ADC2CH_Rslt
			MOVL	@_ADC2CH_Rslt, XAR2
					.endm

;=========================
ADC2CONT_DRV	.macro		;8 cycles
;=========================
; uses PF0 (0WS mem)
			MOVW	DP, #_ADC2CH_Rslt
			MOVL 	XAR4,@_ADC2CH_Rslt		; XAR4: pointer to Net Bus

			MOVW	DP,#ADCPF0R0>>6
			MOVL 	XAR2,#ADCPF0R0			; XAR2: pointer to ADC buffer regs

; Read Result0 (1st conversion)
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Read Result1 (2nd conversion)		
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input
				.endm


;============================================================================
;	ADC1CH_DRV  Macro module
;============================================================================
;			______________________
;			|	   ADC1CH_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 <--| Rslt		   ADCINx |<--
;		 	|		  	   		  |
;			|_____________________|
;
;	Rslt is a pointer to a Signal Net
;
; Description:
; ------------
; ADC peripheral Driver interface.
; Assumes address of 1st Net Bus Address is in Rslt
; Note: ADC1CH_DRV does not start a new conversion, it relys on H/W SOC from EPWM 
;
;==================================================================================
ADC1CH_DRV_INIT	.macro
;=======================
; Variable Definitions
_ADC1CH_Rslt		.usect "ADC1CH_CONT_DRV_Data",2,1,1		; Output Terminal 1


;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_ADC1CH_Rslt

		; actual macro code starts here
			MOVW	DP, #_ADC1CH_Rslt
			MOV		@_ADC1CH_Rslt, #0
			MOV		@(_ADC1CH_Rslt+1), #0
					.endm

;======================
ADC1CH_DRV		.macro
; uses PF0 (0WS mem)
			MOVW	DP, #_ADC1CH_Rslt
			MOVL 	XAR4,@_ADC1CH_Rslt		; XAR4: pointer to Net Bus

			MOVW	DP,#ADCPF0R0>>6
			MOVL 	XAR2,#ADCPF0R0			; XAR2: pointer to ADC buffer regs

; Read Result0 (1st conversion)
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input

; Reset the sequencer 1
			MOVW 	DP,#ADCTRL2>>6
			MOV 	AL,@ADCTRL2
			OR 		AL,#RST_SEQ1
			MOV     @ADCTRL2,AL	
				.endm


;============================================================================
;	ADC1CONT_DRV  Macro module (uses ADC mirror regs in PF0)
;============================================================================
;			______________________
;			|	  ADC1CONT_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 <--| Rslt		   ADCINx |<--
;		 	|		  	   		  |
;			|_____________________|
;
;	Rslt is a pointer to a Signal Net
;
; Description:
; ------------
; ADC peripheral Driver interface.
; 
;
; Revision History:
;==================================================================================
ADC1CONT_DRV_INIT	.macro
;=======================
; Variable Definitions
_ADC1CH_Rslt		.usect "ADC1CH_CONT_DRV_Data",2,1,1		; Output Terminal 1


;Publish Terminal Pointers for access from the C environment (optional)
;======================================================================
					.def 	_ADC1CH_Rslt

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #DummyNet
			MOVW	DP, #_ADC1CH_Rslt
			MOVL	@_ADC1CH_Rslt, XAR2
					.endm

;=========================
ADC1CONT_DRV	.macro		;6 cycles
;=========================
; uses PF0 (0WS mem)
			MOVW	DP, #_ADC1CH_Rslt
			MOVL 	XAR4,@_ADC1CH_Rslt		; XAR4: pointer to Net Bus

			MOVW	DP,#ADCPF0R0>>6
			MOVL 	XAR2,#ADCPF0R0			; XAR2: pointer to ADC buffer regs

; Read Result0 (1st conversion)
			MOV 	ACC,*XAR2++<<3
			MOV 	*XAR4++,AL				; Q15 format, Unipolar input
				.endm


;FILE_TAG: .\lib\dpslib280x\include\CntlPiMacro.inc 

;============================================================================
;	CONTROL_LAW Macro module - PI
;============================================================================
;			______________________
;			|	   CNTL_PI    	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| Ref			  	  |
;			|				  Out |-->
;		 -->| Fdbk			  	  |
;			|_____________________|
;
;		Ref, Fdbk, Out: pointers to Signal Nets
;
; Description:
; ------------
; Performs a second order difference equation of the form:
;
;
; U(n)= Kp*E(n) + Ki * I(n) 
;
; where
;		E(n)   => present error
;		I(n)   => integral accumulation
;		E(n-2) => error from 2 samples past
;
;		|--------|
;		| E(n)   |0  CNTL_PI_DBUFF
;       |        |1 
;		|--------|
;		| I(n)   |2
;       |        |3 
; 		|--------|
;		| I(n)   |4
;       | temp   |5 
; 		|--------|
;       | SatFlag|6
;       |--------|	
;
;Co-efficient array structure
;		|--------|
;       | IsatU  |0 32-bit integral saturation
;       |        |1 
;		|--------|
;       | IsatL  |2 32-bit integral saturation
;       |        |3 
;		|--------|
;       | Ki     |4 16-bit integral gain co-efficient
;		|--------|
;       | Kp     |5 16-bit integral gain co-efficient
;		|--------|
;       | SatU   |6 32-bit integral saturation
;       |        |7 
;		|--------|
;       | SatL   |8 32-bit integral saturation
;       |        |9 
;		|--------|
;
;
;====================================
CNTL_PI_INIT	.macro x
;====================================
; Variable Declarations
;------------------------------------------------------------------------------
; Input, output pointers: 
; Pointers are 32-bits wide on the 28xx CPU - thus there need to be 2 words 
; of storage per pointer 
;------------------------------------------------------------------------------
_CNTL_PI_Ref:x:		.usect "CNTL_PI_Data:x:",2 	; Space for the input ptr
_CNTL_PI_Fdbk:x:	.usect "CNTL_PI_Data:x:",2 	; Space for the feedback ptr
_CNTL_PI_Coeff:x:	.usect "CNTL_PI_Data:x:",2 	; Space for the feedback ptr
_CNTL_PI_Out:x:		.usect "CNTL_PI_Data:x:",2 	; Space for the output ptr
_CNTL_PI_DBUFF:x: 	.usect "CNTL_PI_Data:x:",7	; "Local" memory (history) 
_CNTL_filler:x:     .usect "CNTL_PI_Data:x:",1	; "Local" memory (history) 
CNTL_PI_temp:x:     .usect "CNTL_PI_Data:x:",2	; "Local" memory (history) 

;Publish Terminal Pointers for access from the C environment (optional)
			.def 	_CNTL_PI_Ref:x:
			.def 	_CNTL_PI_Fdbk:x:
			.def 	_CNTL_PI_Out:x:
			.def 	_CNTL_PI_Coeff:x:

		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_CNTL_PI_Ref:x:
			MOVL	@_CNTL_PI_Ref:x:, XAR2
			MOVL	@_CNTL_PI_Fdbk:x:, XAR2
			MOVL	@_CNTL_PI_Coeff:x:, XAR2
			MOVL	XAR2, #DummyNet
			MOVL	@_CNTL_PI_Out:x:, XAR2

		; Zero the Data Buffer
			MOVL 	XAR2,#_CNTL_PI_DBUFF:x:		; Point XAR2 to the buffer
			RPT		#5 								; Repeat 6 times
			||MOV	*XAR2++, #0						; write 0s to the buffer.

				.endm

;========================
CNTL_PI	.macro x
;========================
			MOVW	DP, #_CNTL_PI_Ref:x:
			MOVL 	XAR4,@_CNTL_PI_Ref:x:		; Net pointer to Ref (XAR4)
			MOVL 	XAR5,@_CNTL_PI_Fdbk:x:		; Net pointer to Fdbk (XAR5)
			MOVL 	XAR6,@_CNTL_PI_Out:x:		; Net pointer to Out (XAR6)
			MOVL    XAR7,@_CNTL_PI_Coeff:x:		; Local coefficient pointer (XAR7)

			SETC    SXM,OVM 
			MOV 	ACC,*XAR4					;Q15
			SUB		ACC,*XAR5					;Q15
			LSL		ACC,#14						;Q31

		; Diff equation

			MOV		@_CNTL_PI_DBUFF:x:+6, #0	; Zero out the saturation flag

			MOVL	@_CNTL_PI_DBUFF:x:+0, ACC	; Store the error
			ADDL	ACC, @_CNTL_PI_DBUFF:x:+2   ; Add the new error to the previous integral
			MINL	ACC, *XAR7++  				; Get the Minimum of the upper limit or the
												; new integral - saturation on upper side.
			MAXL	ACC, *XAR7++				; Get the maximum of the lower limit or the 
												; new integral - saturation on the lower side.
			MOVL	@_CNTL_PI_DBUFF:x:+4, ACC	; Store new integral in temp storage

			MOVL 	XT,@_CNTL_PI_DBUFF:x:+4		; XT=I(n),Q31
			QMPYL	P, XT, *XAR7++				; Compute P=Ki*I(n)
			MOVL	XT,@_CNTL_PI_DBUFF:x:+0		; Load the error in XT
			QMPYL	ACC, XT, *XAR7++			; Compute ACC=Kp*E(n)
			ADDL	ACC, P						; Compute ACC=Kp*E(n) + Ki*I(n)
			MOV  	T, *XAR4					; XT = U(n)
			MOV		TL, #0
			QMPYL	P, XT, *XAR7++				; P  = Un*Kf

			ADDL	ACC, P						; Compute ACC=Kp*E(n) + Ki*I(n) + Un*Kf
			LSL		ACC, #1

;			MOVL	@CNTL_PI_temp:x:, ACC		; Safe 1 bit shift
;			ADDL	ACC, @CNTL_PI_temp:x:		; 
;			MOVL	@CNTL_PI_temp:x:, ACC		; Safe 1 bit shift
;			ADDL	ACC, @CNTL_PI_temp:x:		; 
;			MOVL	@CNTL_PI_temp:x:, ACC		; Safe 1 bit shift
;			ADDL	ACC, @CNTL_PI_temp:x:		; 
;			MOVL	@CNTL_PI_temp:x:, ACC		; Safe 1 bit shift
;			ADDL	ACC, @CNTL_PI_temp:x:		; 

			NORM	ACC, *
			NORM	ACC, *
			NORM	ACC, *
			NORM	ACC, *
			NORM	ACC, *
			NORM	ACC, *
						
			MINL	ACC, *XAR7++  				; Get the Minimum of the upper limit or the
												; new control output - saturation on upper side.
			MOVB	@_CNTL_PI_DBUFF:x:+6, #1, C	; Saturation happened so set the flag to 1

			MAXL	ACC, *XAR7++				; Get the maximum of the lower limit or the 
												; new control output - saturation on the lower side.
			MOVB	@_CNTL_PI_DBUFF:x:+6, #1, LT  ; Saturation happened, so store a 1

			MOV		*XAR6, AH					; Store new control output

			TBIT	@_CNTL_PI_DBUFF:x:+6,#1		; Copy the "saturation happened" flag to TC bit
			MOVL	ACC,@_CNTL_PI_DBUFF:x:+4	; Load temporary integral storage
			MOVL	@_CNTL_PI_DBUFF:x:+2, ACC, NTC	; Store integral if saturation flag is cleared


			.endm


	;FILE_TAG: .\lib\drvlib280x\include\PWM_DriverMacro.inc 


;=================================================================================
;	BUCK_DRV n  driver module - 2 channel Buck converter s/w driver
;=================================================================================
;			______________________
;			|	   BUCK_DRV 	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| InA		   EPWMnA |--> Regular PWM output
;		 	|		  	     	  |
;		 -->| InB	  	   EPWMnB |--> Regular PWM output
;			|_____________________|
;
;	InA, InB, are pointers to signal nets.
;   Peripheral Resources used: EPWMn module
;
; Description:
; ------------
; Buck converter peripheral Driver interface
; n = 1, 2, 3, 4, 5, 6
;
;=================================================================================
;=============================
BUCK_DRV_INIT		.macro	n
;=============================
; Variable Declarations
_BUCK_InA:n:		.usect "BUCK_DRV_Data",2,1,1	; Input Terminal 1
_BUCK_InB:n:		.usect "BUCK_DRV_Data",2		; Input Terminal 2
buck_period:n:		.usect "BUCK_DRV_Data",1 		; BUCK period value

;Publish Terminal Pointers for access from the C environment
;===========================================================
					.def 	_BUCK_InA:n:
					.def 	_BUCK_InB:n:

		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_BUCK_InA:n:
			MOVL	@_BUCK_InA:n:, XAR2
			MOVL	@_BUCK_InB:n:, XAR2

			MOVW 	DP,#TBPRD:n:>>6
			MOV		ACC, @TBPRD:n:
			LSL		ACC,#1					; used instead of PM shift of 1
			MOVW	DP,#buck_period:n:
			MOV		@buck_period:n:, ACC	; buck_period=(TBPRDn x 2)
					.endm

;=========================
BUCK_DRV		.macro	n
;=========================
			MOVW	DP, #_BUCK_InA:n:
			MOVL 	XAR2,@_BUCK_InA:n:		; Net pointer for InA  (XAR2)
			MOVL 	XAR3,@_BUCK_InB:n:		; Net pointer for InB  (XAR3)
			MOVL 	XAR4,#CMPA:n:			; point to Compare A (XAR4)

		; Output for EPWMnA
			MOV 	T,*XAR2
			MPYU 	ACC,T,@buck_period:n:
			MOV 	*XAR4++,AH				; output value to CMPAn

		; Output for EPWMnB
			MOV 	T,*XAR3
			MPYU 	ACC,T,@buck_period:n:
			MOV 	*XAR4,AH				; output value to CMPBn
				.endm


;============================================================================
;	MPIL_DRV n, N  Macro module driver
;============================================================================
;						SyncIn
;						   |
;				___________|___________
;				|	  	MPIL_DRV	  |
;				|~~~~~~~~~~~~~~~~~~~~~|
;			 	| 		     EPWM(n)A |--> (phase1)
;			 	| 		  	     	  |
;			 -->| Duty	   EPWM(n+1)A |--> (phase2)
;			 	| 		  	   :  	  |
;			 	| 		  	   : 	  |
;			 	| 		 EPWM(n+N-1)A |--> (phaseN)
;				|_____________________|
;						   |
;						   |
;						SyncOut
; Description:
; ------------
; PWM peripheral Driver Configuration for Multiphase interleaved modulation
; n = 1st ePWM module (i.e. Master)
; N = number of phases, depends on device.  For 2808 N=6 max
; e.g. if n=2, N=3, then  ePWM2 (phase1), ePWM3 (phase2), ePWM4 (phase3)
;
;=============================================================================
;==============================
MPIL_DRV_INIT		.macro n, N
;==============================
; Variable Declarations
_MPIL_Duty:n:		.usect "MPIL_DRV_Data",2,1,1	; Input Terminal 1
mpil_period:n:		.usect "MPIL_DRV_Data",1 		; MPIL period value


;Publish Terminal Pointers for access from the C environment
;===========================================================
					.def 	_MPIL_Duty:n:

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_MPIL_Duty:n:
			MOVL	@_MPIL_Duty:n:, XAR2

			MOVW 	DP,#TBPRD:n:>>6
			MOV		ACC, @TBPRD:n:
			MOVW	DP,#mpil_period:n:
			MOV		@mpil_period:n:, ACC	;mp3_period=TBPRD1
					.endm

;===========================
MPIL_DRV		.macro n, N
;===========================
			MOVW	DP, #_MPIL_Duty:n:
			MOVL 	XAR3,@_MPIL_Duty:n:		; Net pointer for Duty (XAR3)
			MOVL 	XAR2,#CMPA:n:			; point to Compare An  (XAR2)

; Output same Duty value to all phases			
			MOV 	T,*XAR3
			MPY 	ACC,T,@mpil_period:n:
			LSL		ACC,#1
			;phase 1
			MOV 	*XAR2,AH				; output Duty to CMPA(n)

	.if(N>1);phase 2
			ADDB	XAR2, #0x40				; Point to next EPWM module
			MOV 	*XAR2,AH				; output Duty to CMPA(n+1)
	.endif

	.if(N>2);phase 3
			ADDB	XAR2, #0x40				; Point to next EPWM module
			MOV 	*XAR2,AH				; output Duty to CMPA(n+2)
	.endif

	.if(N>3);phase 4
			ADDB	XAR2, #0x40				; Point to next EPWM module
			MOV 	*XAR2,AH				; output Duty to CMPA(n+3)
	.endif

	.if(N>4);phase 5
			ADDB	XAR2, #0x40				; Point to next EPWM module
			MOV 	*XAR2,AH				; output Duty to CMPA(n+4)
	.endif

	.if(N>5);phase 6
			ADDB	XAR2, #0x40				; Point to next EPWM module
			MOV 	*XAR2,AH				; output Duty to CMPA(n+5)
	.endif
				.endm


;=================================================================================
;	PFC2PHIL_DRV  Macro module driver
;=================================================================================
;			______________________
;			|	 PFC2PHIL_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| Duty		   EPWM1A |--> (PFC Phase A switch)
;		 	| 		  	     	  |
;		 -->| Adj	  	   EPWM2A |--> (PFC Phase B switch)
;			|_____________________|
;
;	Duty, Adj, are pointers to signal nets.
;   Peripheral Resources used: EPWM1 and EPWM2 modules
;
; Description:
; ------------
; PWM peripheral Driver interface for PFC 2 phase interleaved modulation
;
;=================================================================================
;==========================
PFC2PHIL_DRV_INIT	.macro
;==========================
; Variable Declarations
_PFC2PHIL_Duty		.usect "PFCIL_data",2,1,1	; Input Terminal 1
_PFC2PHIL_Adj		.usect "PFCIL_data",2 		; Input Terminal 2
pfc_period			.usect "PFCIL_data",1 		; PFC full period count value
pfc_temp			.usect "PFCIL_data",1 		; temp storage value


;Publish Terminal Pointers for access from the C environment
;===========================================================
					.def 	_PFC2PHIL_Duty
					.def 	_PFC2PHIL_Adj

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_PFC2PHIL_Duty
			MOVL	@_PFC2PHIL_Duty, XAR2
			MOVL	@_PFC2PHIL_Adj, XAR2

			MOVW 	DP,#TBPRD1>>6
			MOV		ACC, @TBPRD1
			MOVW	DP,#pfc_period
			MOV		@pfc_period, ACC		;pfc_period=(Timer2 Period)

					.endm

;======================
PFC2PHIL_DRV	.macro
;======================
			MOVW	DP, #_PFC2PHIL_Duty
			MOVL 	XAR4,@_PFC2PHIL_Duty		; Net pointer to Duty (XAR4)
			MOVL 	XAR5,@_PFC2PHIL_Adj			; Net pointer to Adj (XAR5)

			MOVL 	XAR2,#CMPA1					; Pointer to EPWM1-CMPA compare reg (XAR2)
			MOVL 	XAR3,#CMPA2					; Pointer to EPWM2-CMPA compare reg (XAR3)
	
	; Normalize and update Phase A duty cycle comparator
			MOV 	T,*XAR4
			MPY 	ACC,T,@pfc_period
			LSL		ACC,#1
			MOV 	*XAR2,AH					; Write to CMPA1

	; Update Phase B duty cycle comparator
			
		; Adjust the phase B duty cycle using the offset calculated elsewhere
			MOV 	ACC,*XAR4<<9				; Acc = Duty * 512
			ADD 	ACC,*XAR5<<9				; Acc = (Duty + Adj) * 512
		; Saturate the result to limits of control law stack
;			SUBB	XAR7,#4
;			MINL 	ACC,*XAR7++					
;			MAXL 	ACC,*XAR7++					
;			LSL		ACC,#7					; shift result into Q15 format
;			MOV		@pfc_temp, AL			; store temporarily

		; Normalize and update Phase B duty cycle comparator
;			MOV 	T,@pfc_temp				; load "adjusted" duty in T
			MOV 	T,*XAR4
			MPY 	ACC,T,@pfc_period
			LSL		ACC,#1
			MOV 	*XAR3,AH				; Write to CMPA2
			
				.endm


;=================================================================================
;	HHB_DRV  Macro module driver
;=================================================================================
;			______________________
;			|	 	HHB_DRV		  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 	| 			   EPWMnA |--> (HH-bridge Upper switch)
;		 -->| Duty	  	     	  |
;		 	| 		  	   EPWMnB |--> (HH-bridge Lower switch)
;			|_____________________|
;
;	Duty, is a pointer to signal nets.
;   Peripheral Resources used: EPWMn module
;
; Description:
; ------------
; PWM peripheral Driver interface for Half-H bridge modulation
;
;=================================================================================
;==========================
HHB_DRV_INIT	.macro
;==========================
; Variable Declarations
_HHB_Duty			.usect "HHB_data",2,1,1		; Input Terminal 1
HHbMaxCount			.usect "HHB_data",1 		; HHB full count value
HHbMinCount			.usect "HHB_data",1 		; HHB min count value

;Publish Terminal Pointers for access from the C environment
;===========================================================
					.def 	_HHB_Duty

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_HHB_Duty
			MOVL	@_HHB_Duty, XAR2

			MOVW 	DP,#TBPRD3>>6
			MOV		ACC, @TBPRD3
			SUB		ACC, @DBRED3
			MOVW	DP,#HHbMaxCount
			MOV		@HHbMaxCount, ACC	;HHbMaxCount=(HHB_PERIOD - HHB_DEADBAND)

			MOVW 	DP,#DBRED3>>6
			MOV		ACC, @DBRED3
			MOVW	DP,#HHbMinCount
			MOV		@HHbMinCount, ACC	;HHbMinCount = HHB_DEADBAND

				.endm

;======================
HHB_DRV		.macro
;======================
			MOVW	DP, #_HHB_Duty
			MOVL 	XAR2,@_HHB_Duty			; Net pointer to Duty (XAR2)
			MOVL 	XAR4,#CMPA3				; Pointer to EPWMn-CMPA compare reg (XAR4)
	
	; Normalize and update Phase A duty cycle comparator
			MOV 	T,*XAR2
			MPY 	ACC,T,@HHbMaxCount
			LSL		ACC,#1
			ADD		ACC, @HHbMinCount<<16
			MOV 	*XAR4,AH				; Write to CMPA3

			.endm


;============================================================================
;	PSFB_DRV  Macro module driver
;============================================================================
;			______________________
;			|	    PSFB_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| phase		   EPWMnA |--> (right leg upper switch)
;		 -->| dbLeft  	   EPWMnB |--> (right leg Lower switch)
;		 -->| dbRight  EPWM(n+1)A |--> (left leg upper switch)
;		 	| 		   EPWM(n+1)B |--> (left leg Lower switch)
;			|_____________________|
;
;	phase, dbLeft, dbRight, are pointers to signal nets.
;   Peripheral Resources used: EPWMn and EPWM(n+1) modules
;
; Description:
; ------------
; PWM peripheral Driver interface for PSFB w/ZVS modulation
; Note: 2 options are possible
;	1) call PSFB_DRV if both phase and DB are updated at same rate
;	2) call PSFB_PHASE_DRV and PSFB_DB_DRV as separate macros. This allows
;	   Phase and DB control to be updated at different rates.  This saves
;	   cycles in the higher speed phase control loops.
;
;=================================================================================
;========================
PSFB_DRV_INIT	.macro	n
;========================
; Variable Declarations
_PSFB_phase:n:		.usect "PSFB_DRV_Data",2,1,1	; Input Terminal 1
_PSFB_dbLeft:n:		.usect "PSFB_DRV_Data",2		; Input Terminal 2
_PSFB_dbRight:n:	.usect "PSFB_DRV_Data",2		; Input Terminal 3
psfb_hlf_period:n:	.usect "PSFB_DRV_Data",1 		; PSFB half period count value


;Publish Terminal Pointers for access from the C environment
;===========================================================
				.def 	_PSFB_phase:n:
				.def 	_PSFB_dbLeft:n:
				.def 	_PSFB_dbRight:n:

		; set terminals to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_PSFB_phase:n:
			MOVL	@_PSFB_phase:n:, XAR2
			MOVL	@_PSFB_dbLeft:n:, XAR2
			MOVL	@_PSFB_dbRight:n:, XAR2

			MOVW 	DP,#TBPRD:n:>>6			
			MOV		ACC, @TBPRD:n:				;fetch Period value set by C code
			LSR		AL,#1
			MOVW	DP,#psfb_hlf_period:n:
			MOV		@psfb_hlf_period:n:, ACC	;psfb_hlf_period=(TBPRD period value)/2
				.endm


;==========================
PSFB_DRV		.macro	n	; use if phase and DB controlled at same rate
;==========================
			MOVW	DP, #_PSFB_phase:n:
			MOVL 	XAR2,@_PSFB_phase:n:	; Net pointer for phase (XAR2)
			MOVL 	XAR3,@_PSFB_dbLeft:n:	; Net pointer for dbLeft (XAR3)
			MOVL 	XAR4,@_PSFB_dbRight:n:	; Net pointer for dbRight (XAR4)

; Phase Adjustment between Left and Right Legs
			MOVL 	XAR5,#(TBPHS:n: + 0x40)	; Point to Phase register (n+1)
			MOV 	T,*XAR2
			MPY 	ACC,T,@psfb_hlf_period:n:
			LSL 	ACC,#1
			MOV 	*XAR5,AH

; Deadband Adjustment for Right leg (module EPWM(n+1) )
			MOVL 	XAR5,#(DBRED:n: + 0x40)	; Point to DBRED in module EPWM(N+1)
			MOV		ACC, *XAR4				; Fetch Right leg Deadband value
			MOV		*XAR5++, AL				; update DBRED(n+1)
			MOV		*XAR5, AL				; update DBFED(n+1)

; Deadband Adjustment for Left leg (module EPWMn)
			MOVL 	XAR5,#DBRED:n:			; Point to DBRED in module EPWMn
			MOV		ACC, *XAR3				; Fetch Left leg Deadband value
			MOV		*XAR5++, AL				; update DBREDn
			MOV		*XAR5, AL				; update DBFEDn
				.endm


;===========================
PSFB_PHASE_DRV		.macro	; use if phase controlled at different rate to DB
;===========================
; Phase adjust only
			MOVW	DP, #_PSFB_phase
			MOVL 	XAR2,@_PSFB_phase		; Net pointer for phase (XAR2)

; Phase Adjustment between Left and Right Legs
			MOVL 	XAR5,#TBPHS2			; Point to Phase register #2
			MOV 	T,*XAR2
			MPY 	ACC,T,@psfb_hlf_period
			LSL 	ACC,#1
			MOV 	*XAR5,AH
					.endm


;======================
PSFB_DB_DRV		.macro	; use if DB controlled at different rate to phase
;======================
; Dead-band adjust only
			MOVW	DP, #_PSFB_dbLeft
			MOVL 	XAR3,@_PSFB_dbLeft		; Net pointer for dbLeft (XAR3)
			MOVL 	XAR4,@_PSFB_dbRight		; Net pointer for dbRight (XAR4)

; Deadband Adjustment for Right leg (module EPWM2)
			MOVL 	XAR5,#DBRED2	; Point to DBRED in module EPWM2
			MOV		ACC, *XAR4		; Fetch Right leg Deadband value
			MOV		*XAR5++, AL		; update DBRED
			MOV		*XAR5, AL		; update DBFED

; Deadband Adjustment for Left leg (module EPWM1)
			MOVL 	XAR5,#DBRED1	; Point to DBRED in module EPWM1
			MOV		ACC, *XAR3		; Fetch Left leg Deadband value
			MOV		*XAR5++, AL		; update DBRED
			MOV		*XAR5, AL		; update DBFED
					.endm

;============================================================================
;	HR_PSFB_DRV  Macro module driver
;============================================================================
;			______________________
;			|	 HR_PSFB_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| phase		   EPWM1A |--> (right leg upper switch)
;		 -->| dbLeft  	   EPWM1B |--> (right leg Lower switch)
;		 -->| dbRight  	   EPWM2A |--> (left leg upper switch)
;		 	| 		 	   EPWM3A |--> (left leg Lower switch)
;			|_____________________|
;
;	phase, dbLeft, dbRight, are pointers to signal nets.
;   Peripheral Resources used: EPWM1, EPWM2, EPWM3 modules
;
; Description:
; ------------
; PWM peripheral Driver interface for PSFB modulation
; Note: 2 options are possible
;	1) call HR_PSFB_DRV if both phase and DB are updated at same rate
;	2) call HR_PSFB_PHASE_DRV and HR_PSFB_DB_DRV as separate macros. This allows
;	   the phase and DB control to be updated at different rates.  This saves
;	   cycles in the higher speed phase control loop.
;
;=================================================================================
;=======================
HR_PSFB_DRV_INIT	.macro
;=======================
; Variable Declarations
_PSFB_phase		.usect "HR_PSFB_DATA",2,1,1	; Input Terminal 1
_PSFB_dbLeft	.usect "HR_PSFB_DATA",2		; Input Terminal 2
_PSFB_dbRight	.usect "HR_PSFB_DATA",2		; Input Terminal 3
_SFPSFB		  	.usect "HR_PSFB_DATA",1 		; HR PSFB scale factor
hr_psfb_hlfprd	.usect "HR_PSFB_DATA",1 		; PSFB half period count value

;Publish Terminal Pointers for access from the C environment
;===========================================================
				.def 	_PSFB_phase
				.def 	_PSFB_dbLeft
				.def 	_PSFB_dbRight
				.def 	_SFPSFB

		; set terminals to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_PSFB_phase
			MOVL	@_PSFB_phase, XAR2
			MOVL	@_PSFB_dbLeft, XAR2
			MOVL	@_PSFB_dbRight, XAR2

			MOVW 	DP,#TBPRD1>>6
			MOV		ACC, @TBPRD1
			MOVW	DP,#hr_psfb_hlfprd
			MOV		@hr_psfb_hlfprd, ACC	; hr_psfb_hlfprd=(TBPRD1 x 2)
		; This is the start value only
			MOV		@_SFPSFB, #(66*256)		; Initial value for 100MHz case
					.endm

;======================
HR_PSFB_DRV	.macro	; use if phase and DB controlled at same rate
;======================
			MOVW	DP, #_PSFB_phase
			MOVL 	XAR2,@_PSFB_phase		; Net pointer for phase (XAR2)
			MOVL 	XAR3,@_PSFB_dbLeft		; Net pointer for dbLeft (XAR3)
			MOVL 	XAR4,@_PSFB_dbRight		; Net pointer for dbRight (XAR4)

; Phase Adjustment between Left and Right Legs
			MOVL 	XAR5,#TBPHSHR2			; Point to Phase register #2
			MOV 	T,*XAR2
			MPYU 	ACC,T,@hr_psfb_hlfprd
			MOV		T,@_SFPSFB
			MPYU	P,T,@AL                 ; P = T * AL
			MOVH	@AL,P
			ADD		ACC, #0x17F				; Rounding (0.5 LSB)
			MOVL	*XAR5,ACC 				; TBPHS:TBPHSHR(31:8) = ACC
			MOVL 	XAR5,#TBPHSHR3			; Point to ZVS Phase register #3
			MOVL	*XAR5,ACC 				; TBPHS:TBPHSHR(31:8) = ACC

; Deadband Adjustment for Left leg (module EPWM1)
			MOVL 	XAR5,#DBRED1	; Point to DBRED in module EPWM1
			MOV		ACC, *XAR3		; Fetch Left leg Deadband value
			MOV		*XAR5++, AL		; update DBRED
			MOV		*XAR5, AL		; update DBFED

; Deadband Adjustment for Right leg upper switch (module EPWM2)
			MOVL 	XAR5,#DBRED2	; Point to DBRED in module EPWM2
			MOV		ACC, *XAR4		; Fetch Right leg Deadband value
			MOV		*XAR5, AL		; update DBRED

; Deadband Adjustment for Right leg lower switch (module EPWM3)
			MOVL 	XAR5,#DBRED3	; Point to DBRED in module EPWM2
			MOV		ACC, *XAR4		; Fetch Right leg Deadband value
			MOV		*XAR5, AL		; update DBRED
				.endm

;=================================================================================
;	PWMDAC_DRV  driver Macro module - Bipolar or Signed Q15 inputs
;=================================================================================
;			______________________
;			|	 PWMDAC_DRV	  	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| InA		   EPWMnA |--> to Low-Pass filter (DAC A o/p)
;		 	| 		  	     	  |
;		 -->| InB	  	   EPWMnB |--> to Low-pass filter (DAC B o/p)
;			|_____________________|
;
;	InA, InB, are pointers to signal nets.
;   Peripheral Resources used: EPWM5 module
;
; Description:
; ------------
; PWM DAC peripheral Driver interface - handy for debug purposes
;
;=================================================================================
;==========================
PWMDAC_DRV_INIT		.macro x
;==========================
; Variable Declarations
_PWMDAC_InA:x:		.usect "PWMDAC_DRV_Data",2,1,1		; Input Terminal 1
_PWMDAC_InB:x:		.usect "PWMDAC_DRV_Data",2 			; Input Terminal 2
dac_hlf_period:x:	.usect "PWMDAC_DRV_Data",1 			; DAC half period value


;Publish Terminal Pointers for access from the C environment
;===========================================================
					.def 	_PWMDAC_InA:x:
					.def 	_PWMDAC_InB:x:

		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_PWMDAC_InA:x:
			MOVL	@_PWMDAC_InA:x:, XAR2
			MOVL	@_PWMDAC_InB:x:, XAR2

			MOVW 	DP,#TBPRD:x:>>6
			MOV		ACC, @TBPRD:x:
			LSR		AL,#1
			MOVW	DP,#dac_hlf_period:x:
			MOV		@dac_hlf_period:x:, ACC		;dac_hlf_period=(TBPRD5)/2
					.endm

;======================
PWMDAC_DRV		.macro x
;======================
			MOVW	DP, #_PWMDAC_InA:x:
			MOVL 	XAR3,@_PWMDAC_InA:x:	; Net pointer for InA (XAR3)
			MOVL 	XAR4,@_PWMDAC_InB:x:	; Net pointer for InB (XAR4)
			MOVL 	XAR2,#CMPA:x:			; point to Compare A (XAR2)

; Output Variable to PWMDAC A			
			MOV 	T,*XAR3
			MPY 	ACC,T,@dac_hlf_period:x:
			LSL		ACC,#1
			ADD		ACC,@dac_hlf_period:x:<<16
			MOV 	*XAR2++,AH					; output value to CMPAn
			
; Output Variable to PWMDAC B
			MOV 	T,*XAR4
			MPY 	ACC,T,@dac_hlf_period:x:
			LSL		ACC,#1
			ADD		ACC,@dac_hlf_period:x:<<16
			MOV 	*XAR2,AH					; output value to CMPBn
				.endm


;=================================================================================
;	HRPWM_DAC_DRV  driver module - Bipolar or Signed Q15 input
;=================================================================================
;			______________________
;			|	 HRPWM_DAC_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 	|			   EPWM1A |--> to Low-Pass filter (DAC A o/p for test)
;		 -->| In	  	     	  |
;		 	|		  	   EPWM1B |--> to Low-pass filter (DAC B o/p for test)
;			|_____________________|
;
;	In, is a pointer to signal nets.
;   Peripheral Resources used: EPWM1+HR module
;
; Description:
; ------------
; HiRes version of PWM_DAC peripheral Driver interface
;
;=================================================================================
;=============================
HRPWM_DAC_DRV_INIT		.macro x
;=============================
; Variable Declarations
_HRPWM_DAC_InPtr:x:	.usect "HRPWMDAC_DRV_Data",2,1,1	; Input Terminal 1
_SFDAC:x:			.usect "HRPWMDAC_DRV_Data",1 		; HR Buck Scale factor
hrdac_hlf_period:x:	.usect "HRPWMDAC_DRV_Data",1 		; HRDAC half period value


;Publish Terminal Pointers for access from the C environment
;===========================================================
					.def 	_HRPWM_DAC_InPtr:x:
					.def 	_SFDAC:x:

		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_HRPWM_DAC_InPtr:x:
			MOVL	@_HRPWM_DAC_InPtr:x:, XAR2

			MOVW 	DP,#TBPRD:x:>>6
			MOV		ACC, @TBPRD:x:
			MOVW	DP,#hrdac_hlf_period:x:
			MOV		@hrdac_hlf_period:x:, ACC	; hrdac_hlf_period=(TBPRDn)
		; This is the start value only
			MOV		@_SFDAC:x:, #(66*256)		; Initial value for 100MHz case
						.endm

;=========================
HRPWM_DAC_DRV		.macro x
;=========================
			MOVW	DP, #_HRPWM_DAC_InPtr:x:
			MOVL 	XAR2,@_HRPWM_DAC_InPtr:x:		; Net pointer for In  (XAR2)
			MOVL 	XAR3,#CMPAHR:x:			

		; Output for EPWM1A (Hi Res)		
			MOV 	T,*XAR2
			MPY 	ACC,T,@hrdac_hlf_period:x:
			ADD		ACC,@hrdac_hlf_period:x:<<15
			MOV		T,@_SFDAC:x:
			MPYU	P,T,@AL                 ; P = T * AL
			MOVH	@AL,P
			ADD		ACC, #0x17F				; Optimize by Round up
			MOVL	*XAR3,ACC 				; CMPA:CMPAHR(31:8) = ACC

		; Output for EPWM1B (Regular Res) Optional - for comparison purpose only
			MOV		*+XAR3[2],AH			; Store ACCH to regular CMPB
					.endm


;=================================================================================
;	HRBUCK_DRV n  driver module - Hi Res Buck converter s/w driver
;=================================================================================
;			______________________
;			|	  HRBUCK_DRV 	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 	|			   EPWMnA |--> HiRes capable output
;		 -->| In	  	     	  |
;		 	|		  	   EPWMnB |--> Regular output
;			|_____________________|
;
;	In, is a pointer to signal nets.
;   Peripheral Resources used: EPWMn+HR module
;
; Description:
; ------------
; HiRes Buck converter peripheral Driver interface
; n = 1, 2, 3, or 4  (5 & 6 will not have HiRes capabilities)
;
;=================================================================================
;=============================
HRBUCK_DRV_INIT		.macro	n
;=============================
; Variable Declarations
_HRBUCK_In:n:		.usect "HRBUCK_DRV_Data",2,1,1	; Input Terminal 1
_SFBUCK:n:			.usect "HRBUCK_DRV_Data",1 		; HR Buck Scale factor
hrbuck_period:n:	.usect "HRBUCK_DRV_Data",1 		; HRBUCK period value

;Publish Terminal Pointers for access from the C environment
;===========================================================
					.def 	_HRBUCK_In:n:
					.def 	_SFBUCK:n:

		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_HRBUCK_In:n:
			MOVL	@_HRBUCK_In:n:, XAR2

			MOVW 	DP,#TBPRD:n:>>6
			MOV		ACC, @TBPRD:n:
			LSL		ACC,#1					; used instead of PM shift of 1
			MOVW	DP,#hrbuck_period:n:
			MOV		@hrbuck_period:n:, ACC	; hrbuck_period=(TBPRDn x 2)
		; This is the start value only
			MOV		@_SFBUCK:n:, #(66*256)	; Initial value for 100MHz case
					.endm

;=========================
HRBUCK_DRV		.macro	n
;=========================
			MOVW	DP, #_HRBUCK_In:n:
			MOVL 	XAR2,@_HRBUCK_In:n:		; Net pointer for In  (XAR2)
			MOVL 	XAR3,#CMPAHR:n:			

		; Output for EPWM1A (Hi Res)		
			MOV 	T,*XAR2
			MPYU 	ACC,T,@hrbuck_period:n:
			MOV		T,@_SFBUCK:n:
			MPYU	P,T,@AL                 ; P = T * AL
			MOVH	@AL,P
			ADD		ACC, #0x17F				; Optimize by Round up
			MOVL	*XAR3,ACC 				; CMPA:CMPAHR(31:8) = ACC

		; Output for EPWM1B (Regular Res) Optional - for comparison purpose only
;			MOV		*+XAR3[2],AH			; Store ACCH to regular CMPB
				.endm




;=================================================================================
;	PFC2PHIL_DRV  Macro module driver
;=================================================================================
;			______________________
;			|	 PFC2PHIL_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| Duty		   EPWM1A |--> (PFC Phase A switch)
;		 	| 		  	     	  |
;		 -->| Adj	  	   EPWM2A |--> (PFC Phase B switch)
;			|_____________________|
;
;	Duty, Adj, are pointers to signal nets.
;   Peripheral Resources used: EPWM1 and EPWM2 modules
;
; Description:
; ------------
; PWM peripheral Driver interface for PFC 2 phase interleaved modulation
;
;=================================================================================
;==========================
PFC2PHIL_DRV_INIT	.macro
;==========================
; Variable Declarations
_PFC2PHIL_Duty		.usect "PFC2PHIL_data",2,1,1	; Input Terminal 1
_PFC2PHIL_Adj		.usect "PFC2PHIL_data",2 		; Input Terminal 2
pfc_period			.usect "PFC2PHIL_data",1 		; PFC full period count value
pfc_temp			.usect "PFC2PHIL_data",1 		; temp storage value


;Publish Terminal Pointers for access from the C environment
;===========================================================
					.def 	_PFC2PHIL_Duty
					.def 	_PFC2PHIL_Adj

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_PFC2PHIL_Duty
			MOVL	@_PFC2PHIL_Duty, XAR2
			MOVL	@_PFC2PHIL_Adj, XAR2

			MOVW 	DP,#TBPRD1>>6
			MOV		ACC, @TBPRD1
			MOVW	DP,#pfc_period
			MOV		@pfc_period, ACC		;pfc_period=(Timer2 Period)

					.endm

;======================
PFC2PHIL_DRV	.macro
;======================
			MOVW	DP, #_PFC2PHIL_Duty
			MOVL 	XAR4,@_PFC2PHIL_Duty		; Net pointer to Duty (XAR4)
			MOVL 	XAR5,@_PFC2PHIL_Adj			; Net pointer to Adj (XAR5)

			MOVL 	XAR2,#CMPA1					; Pointer to EPWM1-CMPA compare reg (XAR2)
			MOVL 	XAR3,#CMPA2					; Pointer to EPWM2-CMPA compare reg (XAR3)
	
	; Normalize and update Phase A duty cycle comparator
			MOV 	T,*XAR4
			MPY 	ACC,T,@pfc_period
			LSL		ACC,#1
			MOV 	*XAR2,AH					; Write to CMPA1

	; Update Phase B duty cycle comparator
			
		; Adjust the phase B duty cycle using the offset calculated elsewhere
			MOV 	ACC,*XAR4<<9				; Acc = Duty * 512
			ADD 	ACC,*XAR5<<9				; Acc = (Duty + Adj) * 512
		; Saturate the result to limits of control law stack
;			SUBB	XAR7,#4
;			MINL 	ACC,*XAR7++					
;			MAXL 	ACC,*XAR7++					
;			LSL		ACC,#7					; shift result into Q15 format
;			MOV		@pfc_temp, AL			; store temporarily

		; Normalize and update Phase B duty cycle comparator
;			MOV 	T,@pfc_temp				; load "adjusted" duty in T
			MOV 	T,*XAR4
			MPY 	ACC,T,@pfc_period
			LSL		ACC,#1
			MOV 	*XAR3,AH				; Write to CMPA2
			
				.endm


;=================================================================================
;	PFC2PHIL_ONECH_DRV  Macro module driver
;=================================================================================
;			______________________
;			|	 PFC2PHIL_DRV	  |
;			|~~~~~~~~~~~~~~~~~~~~~|
;		 -->| Duty		   EPWM1A |--> (PFC Phase A switch)
;		 	| 		  	     	  |
;		 -->| Adj	  	   EPWM1B |--> (PFC Phase B switch)
;			|_____________________|
;
;	Duty, Adj, are pointers to signal nets.
;   Peripheral Resources used: EPWM1 and EPWM2 modules
;
; Description:
; ------------
; PWM peripheral Driver interface for PFC 2 phase interleaved modulation
;
;=================================================================================
;==========================
PFC2PHIL_ONECH_DRV_INIT	.macro	nEPWMChannel
;==========================
; Variable Declarations
_PFC2PHIL_ONECH_Duty	.usect "PFCIL_data",2,1,1	; Input Terminal 1
_PFC2PHIL_ONECH_Adj		.usect "PFCIL_data",2 		; Input Terminal 2
pfc_onech_period		.usect "PFCIL_data",1 		; PFC full period count value
pfc_onech_temp			.usect "PFCIL_data",1 		; temp storage value


;Publish Terminal Pointers for access from the C environment
;===========================================================
					.def 	_PFC2PHIL_ONECH_Duty
					.def 	_PFC2PHIL_ONECH_Adj

		; actual macro code starts here
		; set terminal to point to ZeroNet
			MOVL	XAR2, #ZeroNet
			MOVW	DP, #_PFC2PHIL_ONECH_Duty
			MOVL	@_PFC2PHIL_ONECH_Duty, XAR2
			MOVL	@_PFC2PHIL_ONECH_Adj, XAR2

			MOVW 	DP,#TBPRD:nEPWMChannel:>>6
			MOV		ACC, @TBPRD:nEPWMChannel:
			MOVW	DP,#pfc_onech_period
			ADD		ACC, #1
			MOV		@pfc_onech_period, ACC		;pfc_period=(Timer2 Period)
					.endm

;======================
PFC2PHIL_ONECH_DRV	.macro	nEPWMChannel
;======================
			MOVW	DP, #_PFC2PHIL_ONECH_Duty
			MOVL 	XAR4,@_PFC2PHIL_ONECH_Duty		; Net pointer to Duty (XAR4)
			MOVL 	XAR5,@_PFC2PHIL_ONECH_Adj		; Net pointer to Adj (XAR5)

			MOVL 	XAR2,#CMPA:nEPWMChannel:		; Pointer to EPWM1-CMPA compare reg (XAR2)
			MOVL 	XAR3,#CMPB:nEPWMChannel:		; Pointer to EPWM2-CMPA compare reg (XAR3)
	
	; Normalize and update Phase A duty cycle comparator
			MOV 	T,*XAR4
			MPY 	ACC,T,@pfc_onech_period
			LSL		ACC,#1
			MOV 	*XAR2,AH					; Write to CMPA1

	; Update Phase B duty cycle comparator
			
		; Adjust the phase B duty cycle using the offset calculated elsewhere
			MOV 	AH, #07fffh
			MOV		AL, #0ffffh
			SUB 	AH, *XAR4				; Acc = Duty * 512
			SUB 	AH, *XAR5				; Acc = (Duty + Adj) * 512
			MOV		@pfc_onech_temp, AH

		; Normalize and update Phase B duty cycle comparator
			MOV 	T,@pfc_onech_temp
			MPY 	ACC,T,@pfc_onech_period
			LSL		ACC,#1
			MOV 	*XAR3,AH				; Write to CMPA2
			
				.endm
